(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("underscore"), require("ht-js-data"), require("ht-js-utils"), require("leaflet"), require("rxjs/Observable"), require("rxjs/add/observable/timer"), require("rxjs/add/operator/switchMap"), require("rxjs/add/operator/filter"), require("rxjs/add/operator/take"), require("rxjs/add/operator/map"), require("rxjs/add/operator/share"), require("rxjs/add/operator/takeUntil"), require("rxjs/BehaviorSubject"), require("rxjs/Subject"));
	else if(typeof define === 'function' && define.amd)
		define(["underscore", "ht-js-data", "ht-js-utils", "leaflet", "rxjs/Observable", "rxjs/add/observable/timer", "rxjs/add/operator/switchMap", "rxjs/add/operator/filter", "rxjs/add/operator/take", "rxjs/add/operator/map", "rxjs/add/operator/share", "rxjs/add/operator/takeUntil", "rxjs/BehaviorSubject", "rxjs/Subject"], factory);
	else if(typeof exports === 'object')
		exports["htMaps"] = factory(require("underscore"), require("ht-js-data"), require("ht-js-utils"), require("leaflet"), require("rxjs/Observable"), require("rxjs/add/observable/timer"), require("rxjs/add/operator/switchMap"), require("rxjs/add/operator/filter"), require("rxjs/add/operator/take"), require("rxjs/add/operator/map"), require("rxjs/add/operator/share"), require("rxjs/add/operator/takeUntil"), require("rxjs/BehaviorSubject"), require("rxjs/Subject"));
	else
		root["htMaps"] = factory(root["underscore"], root["ht-js-data"], root["ht-js-utils"], root["leaflet"], root["Rx"], root["Rx"], root["Rx"], root["Rx"], root["Rx"], root["Rx"], root["Rx"], root["Rx"], root["Rx"], root["Rx"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_0__, __WEBPACK_EXTERNAL_MODULE_5__, __WEBPACK_EXTERNAL_MODULE_7__, __WEBPACK_EXTERNAL_MODULE_15__, __WEBPACK_EXTERNAL_MODULE_18__, __WEBPACK_EXTERNAL_MODULE_19__, __WEBPACK_EXTERNAL_MODULE_20__, __WEBPACK_EXTERNAL_MODULE_21__, __WEBPACK_EXTERNAL_MODULE_22__, __WEBPACK_EXTERNAL_MODULE_23__, __WEBPACK_EXTERNAL_MODULE_24__, __WEBPACK_EXTERNAL_MODULE_25__, __WEBPACK_EXTERNAL_MODULE_26__, __WEBPACK_EXTERNAL_MODULE_38__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 13);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_0__;

/***/ }),
/* 1 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HtMapItems; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_underscore__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_underscore___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_underscore__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__map_item__ = __webpack_require__(3);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__leaflet_map_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__google_map_utils__ = __webpack_require__(6);
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};




var HtMapItems = (function () {
    function HtMapItems(mapType, options) {
        if (options === void 0) { options = {}; }
        this.mapType = mapType;
        this.options = options;
        this.itemEntities = {};
        this.defaultStyle = {};
        this.fadeStyle = {};
        this.defaultOptions = {
            mapType: 'leaflet',
            defaultStyle: {}
        };
        var newoptions = __assign({}, this.defaultOptions, options);
        var defaultStyle = newoptions.defaultStyle;
        if (defaultStyle)
            this.defaultStyle = defaultStyle;
        this.mapUtils = mapType == 'leaflet' ? __WEBPACK_IMPORTED_MODULE_2__leaflet_map_utils__["i" /* LeafletUtils */] : __WEBPACK_IMPORTED_MODULE_3__google_map_utils__["a" /* GoogleMapUtils */];
        this.onReady(options);
    }
    HtMapItems.prototype.onReady = function (options) {
        if (options === void 0) { options = {}; }
    };
    // constructor(mapUtils: MapUtils = LeafletUtils, defaultStyle?) {
    //   if(this.defaultStyle) this.defaultStyle = defaultStyle;
    //   this.mapUtils = mapUtils;
    // }
    HtMapItems.prototype.traceOnMap = function (items, map) {
        this.trace(items, map, true);
    };
    HtMapItems.prototype.trace = function (items, map, setMap) {
        if (setMap === void 0) { setMap = false; }
        items = this.filteredItem(items);
        this.map = map;
        if (items && items.length) {
            this.traceItems(items, setMap);
        }
        else {
            this.removeItems();
        }
        this.bustOlditem();
    };
    HtMapItems.prototype.filteredItem = function (items) {
        return items;
    };
    HtMapItems.prototype.getItem = function (data) {
        return new __WEBPACK_IMPORTED_MODULE_1__map_item__["a" /* HtMapItem */](this.mapType);
    };
    HtMapItems.prototype.itemEffect = function (item) {
    };
    HtMapItems.prototype.traceItemEffect = function (itemEntities) {
    };
    HtMapItems.prototype.extendBounds = function (bounds) {
        bounds = bounds || this.mapUtils.extendBounds();
        var newBounds = __WEBPACK_IMPORTED_MODULE_0_underscore__["reduce"](this.itemEntities, function (bounds, item) {
            return item.extendBounds(bounds);
        }, bounds);
        return newBounds;
    };
    HtMapItems.prototype.addClick = function (cb) {
        __WEBPACK_IMPORTED_MODULE_0_underscore__["each"](this.itemEntities, function (item) {
            item.item.on('click', function () {
                cb(item.data);
            });
        });
    };
    HtMapItems.prototype.onHoverIn = function (cb) {
        __WEBPACK_IMPORTED_MODULE_0_underscore__["each"](this.itemEntities, function (item) {
            item.item.on('mouseover', function () {
                // console.log("mouseover");
                cb(item.data);
            });
        });
    };
    HtMapItems.prototype.onHoverOut = function (cb) {
        __WEBPACK_IMPORTED_MODULE_0_underscore__["each"](this.itemEntities, function (item) {
            item.item.on('mouseout', function () {
                cb(item.data);
            });
        });
    };
    ;
    HtMapItems.prototype.unHighlight = function () {
        var _this = this;
        this.onEach(function (item) {
            item.unHighlight(_this.map);
            item.isFaded = true;
        });
    };
    HtMapItems.prototype.highlight = function (data, config) {
        var _this = this;
        if (config === void 0) { config = {}; }
        this.onEach(function (item) {
            if (data) {
                if (item.id != data.id) {
                    _this.unHighlightItem(item);
                }
                else {
                    _this.highlightItem(item, data, config);
                }
            }
            else {
                _this.resetHighlight(item);
            }
        });
    };
    HtMapItems.prototype.unHighlightItem = function (item) {
        item.isFaded = true;
        item.unHighlight(this.map);
    };
    HtMapItems.prototype.highlightItem = function (item, data, config) {
        if (config === void 0) { config = {}; }
        item.isHighlighted = true;
        item.highlight(this.map, data, config);
    };
    HtMapItems.prototype.setFade = function (selectedItem, toFade) {
        var _this = this;
        if (toFade === void 0) { toFade = true; }
        __WEBPACK_IMPORTED_MODULE_0_underscore__["each"](this.itemEntities, function (item) {
            if (toFade) {
                // console.log(this.fadeStyle);
                if (selectedItem && item.id == selectedItem.id) {
                    item.bringToFront();
                }
                else {
                    item.setStyle(_this.fadeStyle);
                }
            }
            else {
                // console.log(this.defaultStyle);
                item.setStyle(_this.defaultStyle);
            }
            // (toFade && item.id == selectedItem.id) ? item.setStyle(this.fadeStyle) : item.setStyle(this.defaultStyle)
        });
    };
    HtMapItems.prototype.resetHighlights = function () {
        var _this = this;
        this.onEach(function (item) {
            _this.resetHighlight(item);
        });
    };
    HtMapItems.prototype.onEach = function (cb) {
        __WEBPACK_IMPORTED_MODULE_0_underscore__["each"](this.itemEntities, function (item) {
            cb(item);
        });
    };
    HtMapItems.prototype.resetHighlight = function (item) {
        item.isFaded = false;
        item.isHighlighted = false;
        item.resetHighlight(this.map);
    };
    HtMapItems.prototype.resetItems = function () {
        var _this = this;
        __WEBPACK_IMPORTED_MODULE_0_underscore__["each"](this.itemEntities, function (item) {
            _this.resetItem(item);
        });
    };
    HtMapItems.prototype.resetItem = function (item) {
        item.reset();
    };
    HtMapItems.prototype.bustOlditem = function () {
        var _this = this;
        __WEBPACK_IMPORTED_MODULE_0_underscore__["each"](this.itemEntities, function (item) {
            if (item.isOld) {
                _this.removeItem(item);
            }
            else {
                item.isOld = true;
            }
        });
    };
    HtMapItems.prototype.traceItems = function (items, setMap) {
        var _this = this;
        if (setMap === void 0) { setMap = false; }
        var traceItems = items.slice();
        // let lastItem = traceItems.pop();
        __WEBPACK_IMPORTED_MODULE_0_underscore__["each"](traceItems, function (item) {
            if (_this.itemEntities[item.id]) {
                _this.updateItem(item, setMap);
            }
            else {
                _this.createItem(item, setMap);
            }
        });
        this.traceItemEffect(this.itemEntities);
        // this.updateItem(lastItem);
    };
    HtMapItems.prototype.updateItem = function (data, setMap) {
        if (setMap === void 0) { setMap = false; }
        var mapitem = this.itemEntities[data.id];
        if (mapitem) {
            mapitem.updateItem(data);
            if (setMap)
                mapitem.setMap(this.map);
            mapitem.update(data, this.map);
            mapitem.onUpdate(data, this.map);
        }
        else {
            this.createItem(data, setMap);
        }
    };
    HtMapItems.prototype.createItem = function (data, setMap) {
        if (setMap === void 0) { setMap = false; }
        var item = this.getItem(data);
        this.itemEffect(item);
        this.itemEntities[data['id']] = item;
        this.updateItem(data, setMap);
    };
    HtMapItems.prototype.removeItem = function (item) {
        item.clear();
        var id = item.id;
        if (this.itemEntities[id])
            delete this.itemEntities[id];
    };
    HtMapItems.prototype.clearAll = function () {
        __WEBPACK_IMPORTED_MODULE_0_underscore__["each"](this.itemEntities, function (item) {
            item.clear();
        });
    };
    HtMapItems.prototype.removeItems = function () {
    };
    return HtMapItems;
}());



/***/ }),
/* 2 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HtMarkerItem; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__map_item__ = __webpack_require__(3);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

var HtMarkerItem = (function (_super) {
    __extends(HtMarkerItem, _super);
    function HtMarkerItem() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HtMarkerItem.prototype.update = function (data, map) {
        var position = this.getPosition(data);
        this.mapUtils.updatePosition(this.item, position);
    };
    HtMarkerItem.prototype.getPosition = function (item) {
        var lat = item.position[0];
        var lng = item.position[1];
        return this.mapUtils.getLatlng({ lat: lat, lng: lng });
    };
    return HtMarkerItem;
}(__WEBPACK_IMPORTED_MODULE_0__map_item__["a" /* HtMapItem */]));



/***/ }),
/* 3 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HtMapItem; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__leaflet_map_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__google_map_utils__ = __webpack_require__(6);
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};


var HtMapItem = (function () {
    function HtMapItem(mapType, options) {
        if (options === void 0) { options = {}; }
        this.mapType = mapType;
        this.options = options;
        this.isFaded = false;
        this.isHighlighted = false;
        this.isOld = false;
        this.googleStyle = {};
        this.leafletStyle = {};
        this.defaultOptions = {
            mapType: 'leaflet',
            defaultStyle: {}
        };
        var newoptions = __assign({}, this.defaultOptions, options);
        var defaultStyle = newoptions.defaultStyle;
        if (defaultStyle)
            this.defaultStyle = defaultStyle;
        this.mapUtils = mapType == 'leaflet' ? __WEBPACK_IMPORTED_MODULE_0__leaflet_map_utils__["i" /* LeafletUtils */] : __WEBPACK_IMPORTED_MODULE_1__google_map_utils__["a" /* GoogleMapUtils */];
        this.setItem();
    }
    HtMapItem.prototype.setItem = function () {
    };
    HtMapItem.prototype.setMapTypeStyle = function () {
        var style = this.mapType == 'leaflet' ? this.leafletStyle : this.googleStyle;
        this.setStyle(style);
    };
    HtMapItem.prototype.update = function (item, map) {
    };
    HtMapItem.prototype.onUpdate = function (item, map) {
    };
    //todo update data rename
    HtMapItem.prototype.updateItem = function (data) {
        this.id = data['id'];
        this.item['id'] = this.id;
        this.data = data;
        this.isOld = false;
        this.dataClass = this.setDataClass(data);
    };
    HtMapItem.prototype.setDataClass = function (data) {
        return null;
    };
    HtMapItem.prototype.extendBounds = function (bounds) {
        bounds = bounds || this.mapUtils.extendBounds();
        return this.mapUtils.extendBounds(this.item, bounds);
    };
    HtMapItem.prototype.setMap = function (map) {
        this.mapUtils.setMap(this.item, map);
    };
    HtMapItem.prototype.clear = function () {
        if (this.item)
            this.mapUtils.clearItem(this.item);
    };
    HtMapItem.prototype.resetHighlight = function (map) {
        this.reset();
    };
    HtMapItem.prototype.reset = function () {
        this.item.isFaded = false;
        this.resetItem();
        this.closeTooltip();
        this.closePopup();
    };
    HtMapItem.prototype.resetItem = function () {
        this.setStyle(this.defaultStyle);
    };
    HtMapItem.prototype.setStyle = function (style) {
        this.mapUtils.setStyle(this.item, style);
    };
    HtMapItem.prototype.getItemInfoContent = function () {
        return this.getInfoContent(this.data);
    };
    HtMapItem.prototype.getInfoContent = function (data) {
        return "";
    };
    HtMapItem.prototype.openPopup = function (item, content) {
        this.mapUtils.openPopup(item, content);
    };
    HtMapItem.prototype.closePopup = function () {
        this.mapUtils.closePopup(this.item);
    };
    HtMapItem.prototype.openTooltip = function (content) {
        this.mapUtils.openTooltip(this.item, content);
    };
    HtMapItem.prototype.closeTooltip = function () {
        this.mapUtils.closeTooltip(this.item);
    };
    HtMapItem.prototype.bringToFront = function () {
        this.mapUtils.bringToFront(this.item);
    };
    HtMapItem.prototype.highlight = function (map, data, config) {
        if (config === void 0) { config = {}; }
    };
    HtMapItem.prototype.unHighlight = function (map) {
    };
    HtMapItem.prototype.setFocus = function (map, config) {
        if (config === void 0) { config = {}; }
        this.mapUtils.setFocus(this.item, map, config);
    };
    return HtMapItem;
}());



/***/ }),
/* 4 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (immutable) */ __webpack_exports__["b"] = ExtendBounds;
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "c", function() { return ExtendBoundsWithPolyline; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "k", function() { return SetStyle; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "j", function() { return SetMap; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return ClearItem; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "d", function() { return GetLatlng; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "l", function() { return setEncodedPath; });
/* harmony export (immutable) */ __webpack_exports__["f"] = HtUpdatePositionPopup;
/* harmony export (immutable) */ __webpack_exports__["e"] = HtUpdatePopup;
/* harmony export (immutable) */ __webpack_exports__["g"] = HtUpdatePositionTooltip;
/* harmony export (immutable) */ __webpack_exports__["h"] = HtUpdateTooltip;
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "i", function() { return LeafletUtils; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_leaflet__ = __webpack_require__(15);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_leaflet___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_leaflet__);
var polyUtil = __webpack_require__(14);

function ExtendBounds(item, bounds) {
    if (item === void 0) { item = null; }
    if (bounds === void 0) { bounds = __WEBPACK_IMPORTED_MODULE_0_leaflet__["latLngBounds"]([]); }
    if (item && item.getElement())
        bounds.extend(item.getLatLng());
    return bounds;
}
;
var ExtendBoundsWithPolyline = function (polyline, bounds) {
    if (polyline === void 0) { polyline = null; }
    if (bounds === void 0) { bounds = __WEBPACK_IMPORTED_MODULE_0_leaflet__["latLngBounds"]([]); }
    if (polyline && polyline.getElement()) {
        bounds.extend(polyline.getBounds());
    }
    return bounds;
};
var SetStyle = function (item, style) {
    item.setStyle(style);
};
var SetMap = function (item, map) {
    if ((item && !item.getElement()) || (item && !item.getElement))
        item.addTo(map);
};
var ClearItem = function (item) {
    item.remove();
    item.off();
};
var GetLatlng = function (_a) {
    var _b = _a === void 0 ? { lat: 0, lng: 0 } : _a, lat = _b.lat, lng = _b.lng;
    return __WEBPACK_IMPORTED_MODULE_0_leaflet__["latLng"](lat, lng);
};
var setEncodedPath = function (polyline, encodedPolyline) {
    var path = polyUtil.decode(encodedPolyline);
    return polyline.setLatLngs(path);
};
function HtUpdatePositionPopup(marker, position, infoContent, defaultOption) {
    if (defaultOption === void 0) { defaultOption = {}; }
    marker.setLatLng(position);
    HtUpdatePopup(marker, infoContent, defaultOption);
}
function HtUpdatePopup(marker, infoContent, defaultOption) {
    if (marker.getPopup()) {
        marker.setPopupContent(infoContent);
    }
    else {
        marker.bindPopup(infoContent, defaultOption);
    }
}
function HtUpdatePositionTooltip(marker, position, infoContent, defaultOption) {
    if (infoContent === void 0) { infoContent = ""; }
    if (defaultOption === void 0) { defaultOption = {}; }
    marker.setLatLng(position);
    if (infoContent)
        HtUpdateTooltip(marker, infoContent, defaultOption);
}
function HtUpdateTooltip(marker, infoContent, defaultOption) {
    if (marker.getTooltip()) {
        marker.setTooltipContent(infoContent);
    }
    else {
        marker.bindTooltip(infoContent, defaultOption);
    }
}
function openTooltip(item, content) {
    if (content)
        item.setTooltipContent(content);
    item.openTooltip();
}
function closeTooltip(item) {
    item.closeTooltip();
}
function openPopup(item, map, content) {
    if (content)
        item.setPopupContent(content);
    item.openPopup();
}
function closePopup(item) {
    item.closePopup();
}
function bringToFront(item) {
    item.bringToFront();
}
function setFocus(item, map, config) {
    if (item && item.getElement() || config.force) {
        var markerCenter = getItemLatlng(item);
        if (config.center)
            map.panTo(markerCenter, { animate: true, duration: 1 });
        if (config.zoom && config.center)
            map.setView(markerCenter, config.zoom);
    }
}
function getItemLatlng(item) {
    return item.getLatLng();
}
function renderMap(elem, options) {
    var map = __WEBPACK_IMPORTED_MODULE_0_leaflet__["map"](elem, options);
    __WEBPACK_IMPORTED_MODULE_0_leaflet__["tileLayer"]('http://{s}.tile.osm.org/{z}/{x}/{y}.png', {
        attribution: '&copy; <a href="http://osm.org/copyright">OpenStreetMap</a> contributors'
    }).addTo(map);
    return map;
}
function updateCirclePosition(circle, position, infoContent, defaultOption) {
    if (infoContent === void 0) { infoContent = ""; }
    if (defaultOption === void 0) { defaultOption = {}; }
    HtUpdatePositionTooltip(circle, position, infoContent, defaultOption);
}
function getCircleMarker() {
    return __WEBPACK_IMPORTED_MODULE_0_leaflet__["circleMarker"]([0, 0]);
}
function getMarker() {
    return __WEBPACK_IMPORTED_MODULE_0_leaflet__["marker"]([0, 0]);
}
function getMarkerCluster(map) {
    // let cluster = L.markerClusterGroup();
    // map.addTo(cluster);
    // return cluster
}
function removeClusterMarkers(cluster) {
}
function removeClusterMarker(cluster, marker) {
}
function addMarkersToCluster(cluster, markers) {
    cluster.addLayers(markers);
    cluster.refreshClusters(markers);
}
function getPolyline() {
    return __WEBPACK_IMPORTED_MODULE_0_leaflet__["polyline"]([]);
}
function setBounds(map, bounds, options) {
    map.flyToBounds(bounds, options);
}
function isValidBounds(bounds) {
    return bounds.isValid();
}
function invalidateSize(map) {
    map.invalidateSize();
}
function getPopup(options) {
    return __WEBPACK_IMPORTED_MODULE_0_leaflet__["popup"](options);
}
function onEvent(item, event, cb) {
    item.on(event, function (e) {
        cb(e);
    });
}
function openPopupPosition(position, map, content, popup) {
}
var LeafletUtils = {
    setMap: SetMap,
    setStyle: SetStyle,
    clearItem: ClearItem,
    extendBounds: ExtendBounds,
    extendBoundsWithPolyline: ExtendBoundsWithPolyline,
    getLatlng: GetLatlng,
    updatePosition: HtUpdatePositionTooltip,
    openTooltip: openTooltip,
    closeTooltip: closeTooltip,
    openPopup: openPopup,
    closePopup: closePopup,
    bringToFront: bringToFront,
    setFocus: setFocus,
    renderMap: renderMap,
    updateCirclePosition: updateCirclePosition,
    getCircleMarker: getCircleMarker,
    getMarker: getMarker,
    getMarkerCluster: getMarkerCluster,
    addMarkersToCluster: addMarkersToCluster,
    removeClusterMarkers: removeClusterMarkers,
    removeClusterMarker: removeClusterMarker,
    getPolyline: getPolyline,
    getPopup: getPopup,
    setEncodedPath: setEncodedPath,
    setBounds: setBounds,
    isValidBounds: isValidBounds,
    invalidateSize: invalidateSize,
    onEvent: onEvent,
    openPopupPosition: openPopupPosition
};


/***/ }),
/* 5 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_5__;

/***/ }),
/* 6 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* unused harmony export ExtendBounds */
/* unused harmony export ExtendBoundsWithPolyline */
/* unused harmony export SetStyle */
/* unused harmony export SetMap */
/* unused harmony export ClearItem */
/* unused harmony export GetLatlng */
/* unused harmony export setEncodedPath */
/* unused harmony export HtUpdatePositionPopup */
/* unused harmony export HtUpdatePopup */
/* unused harmony export HtUpdatePositionTooltip */
/* unused harmony export HtUpdateTooltip */
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return GoogleMapUtils; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_underscore__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_underscore___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_underscore__);

function ExtendBounds(item, bounds, force) {
    if (item === void 0) { item = null; }
    if (force === void 0) { force = false; }
    bounds = bounds || new google.maps.LatLngBounds();
    if ((item && item.getMap() && item.getPosition) || force) {
        var p = item.getPosition();
        var l = { lat: p.lat(), lng: p.lng() };
        bounds.extend(l);
    }
    if (item && item.getMap() && item.getCenter) {
        bounds.extend(item.getCenter());
    }
    return bounds;
}
;
var ExtendBoundsWithPolyline = function (polyline, bounds) {
    if (polyline === void 0) { polyline = null; }
    if (bounds === void 0) { bounds = new google.maps.LatLngBounds(); }
    if (polyline && polyline.getMap()) {
        __WEBPACK_IMPORTED_MODULE_0_underscore__["each"](polyline.getPath().getArray(), function (p) {
            var l = { lat: p.lat(), lng: p.lng() };
            bounds.extend(l);
        });
    }
    return bounds;
};
var SetStyle = function (item, style) {
    item.setOptions(style);
};
var SetMap = function (item, map) {
    if (!map) {
        item.setMap(null);
    }
    else if ((item && !item.getMap()) || (item && !item.getMap)) {
        item.setMap(map);
    }
};
var ClearItem = function (item) {
    item.setMap(null);
};
var GetLatlng = function (_a) {
    var _b = _a === void 0 ? { lat: 0, lng: 0 } : _a, lat = _b.lat, lng = _b.lng;
    return new google.maps.LatLng(lat, lng);
};
var setEncodedPath = function (polyline, encodedPolyline) {
    var path = google.maps.geometry.encoding.decodePath(encodedPolyline);
    return polyline.setPath(path);
};
function HtUpdatePositionPopup(marker, position, infoContent, defaultOption) {
    if (defaultOption === void 0) { defaultOption = {}; }
    marker.setPosition(position);
    HtUpdatePopup(marker, infoContent, defaultOption);
}
function HtUpdatePopup(marker, infoContent, defaultOption) {
    // if(marker.getPopup()) {
    //   marker.setPopupContent(infoContent)
    // } else {
    //   marker.bindPopup(infoContent, defaultOption);
    // }
}
function HtUpdatePositionTooltip(marker, position, infoContent, defaultOption) {
    if (infoContent === void 0) { infoContent = ""; }
    if (defaultOption === void 0) { defaultOption = {}; }
    marker.setPosition(position);
    // if(infoContent) HtUpdateTooltip(marker, infoContent, defaultOption)
}
function HtUpdateTooltip(marker, infoContent, defaultOption) {
    // if(marker.getTooltip()) {
    //   marker.setTooltipContent(infoContent)
    // } else {
    //   marker.bindTooltip(infoContent, defaultOption);
    // }
}
function openTooltip(item, content) {
    // if(content) item.setTooltipContent(content);
    // item.openTooltip()
}
function closeTooltip(item) {
    // item.closeTooltip()
}
function openPopup(item, map, content, popup) {
    if (popup) {
        popup.setContent(content);
        // console.log(item.getPosition().lat());
        popup.open(map, item);
    }
    // if(content) item.setPopupContent(content);
    // item.openPopup()
}
function closePopup(item) {
    // item.closePopup()
}
function bringToFront(item) {
    // item.bringToFront()
}
function setFocus(item, map, _a) {
    var zoom = _a.zoom, _b = _a.force, force = _b === void 0 ? false : _b, center = _a.center;
    if ((item && item.getMap()) || force) {
        var markerCenter = getItemLatlng(item);
        if (center)
            map.setCenter(markerCenter);
        if (zoom && center)
            map.setZoom(zoom);
        // item.setAnimation(google.maps.Animation.DROP);
        // setTimeout(() => {
        //   item.setAnimation(null);
        //
        // }, 1000)
    }
}
function getItemLatlng(item) {
    return item.getPosition();
}
function renderMap(elem, options) {
    return new google.maps.Map(elem, options);
}
function updateCirclePosition(circle, position) {
    circle.setCenter(position);
}
function getCircleMarker() {
    return new google.maps.Marker();
}
function getMarker() {
    return new google.maps.Marker();
}
function getMarkerCluster(map) {
    // console.log("get", map);
    return new MarkerClusterer(map, [], { imagePath: 'https://developers.google.com/maps/documentation/javascript/examples/markerclusterer/m' });
}
function removeClusterMarkers(cluster) {
    cluster.clearMarkers();
}
function removeClusterMarker(cluster, marker) {
    cluster.removeMarker(marker);
}
function addMarkersToCluster(cluster, markers, map) {
    // if(markers.length) console.log(map, "map", markers[0]);
    // cluster.setMap(map);
    var clusterMarkers = cluster.getMarkers();
    markers.forEach(function (marker) {
        // if(markerEntity[marker['id']]) {
        //
        // } else {
        //   cluster.addMarker(marker)
        // }
        //alternate aproach
        if (clusterMarkers.indexOf && clusterMarkers.indexOf(marker) > -1) {
        }
        else {
            cluster.addMarker(marker);
        }
    });
    // var hasId = clusterMarkers && clusterMarkers.length && clusterMarkers[0]['id'];
    // if(hasId) {
    //   let markerEntity = _.indexBy(clusterMarkers, 'id');
    //   markers.forEach((marker) => {
    //     if(markerEntity[marker['id']]) {
    //
    //     } else {
    //       cluster.addMarker(marker)
    //     }
    //   })
    // } else {
    //   _.each(markers, (marker) => {
    //     // console.log(marker.getPosition().lng());
    //     cluster.removeMarker(marker);
    //     cluster.addMarker(marker)
    //     // if(marker.getPosition()) {
    //     //   console.log("hit", marker);
    //     //   cluster.addMarker(marker)
    //     // }
    //   })
    // }
    // cluster.addMarkers(markers)
    // this.markerCluster.addLayers(markers);
    // this.markerCluster.refreshClusters(markers);
}
function getPopup(options) {
    return new google.maps.InfoWindow(options);
}
function getPolyline() {
    return new google.maps.Polyline();
}
function setBounds(map, bounds, padding) {
    if (padding === void 0) { padding = 0; }
    var newBounds = new google.maps.LatLngBounds(bounds.getSouthWest(), bounds.getNorthEast());
    map.fitBounds(newBounds);
}
function isValidBounds(bounds) {
    // console.log(bounds);
    // return !bounds.isEmpty()
    return !getBoundsFix(bounds).isEmpty();
}
function getBoundsFix(bounds) {
    return new google.maps.LatLngBounds(bounds.getSouthWest(), bounds.getNorthEast());
}
function invalidateSize(map) {
    google.maps.event.trigger(map, 'resize');
}
function onEvent(item, event, cb) {
    item.addListener(event, function (e) {
        cb(e);
    });
}
function openPopupPosition(position, map, content, popup) {
    popup.setContent(content);
    popup.setPosition(GetLatlng(position));
    popup.setMap(map);
}
var GoogleMapUtils = {
    setMap: SetMap,
    setStyle: SetStyle,
    clearItem: ClearItem,
    extendBounds: ExtendBounds,
    extendBoundsWithPolyline: ExtendBoundsWithPolyline,
    getLatlng: GetLatlng,
    updatePosition: HtUpdatePositionTooltip,
    openTooltip: openTooltip,
    closeTooltip: closeTooltip,
    openPopup: openPopup,
    closePopup: closePopup,
    bringToFront: bringToFront,
    setFocus: setFocus,
    renderMap: renderMap,
    updateCirclePosition: updateCirclePosition,
    getCircleMarker: getCircleMarker,
    getMarker: getMarker,
    getMarkerCluster: getMarkerCluster,
    addMarkersToCluster: addMarkersToCluster,
    removeClusterMarkers: removeClusterMarkers,
    removeClusterMarker: removeClusterMarker,
    getPolyline: getPolyline,
    getPopup: getPopup,
    setEncodedPath: setEncodedPath,
    setBounds: setBounds,
    isValidBounds: isValidBounds,
    invalidateSize: invalidateSize,
    onEvent: onEvent,
    openPopupPosition: openPopupPosition
};


/***/ }),
/* 7 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_7__;

/***/ }),
/* 8 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HtSegmentsTrace; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__map_items__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_underscore__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_underscore___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_underscore__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__timeline_segment__ = __webpack_require__(9);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__current_user__ = __webpack_require__(12);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__marker_item__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__entities_segment_polylines__ = __webpack_require__(27);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__entities_stop_markers__ = __webpack_require__(30);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__entities_action_markers__ = __webpack_require__(32);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_ht_js_data__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_ht_js_data___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_8_ht_js_data__);
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};









var HtSegmentsTrace = (function () {
    function HtSegmentsTrace(mapType, options) {
        if (mapType === void 0) { mapType = 'leaflet'; }
        if (options === void 0) { options = {}; }
        var _this = this;
        this.options = options;
        this.timelineSegment = new __WEBPACK_IMPORTED_MODULE_2__timeline_segment__["a" /* TimelineSegment */]();
        this.allowedEvents = {};
        this.initBaseItems(mapType);
        this.timelineSegment.head$.filter(function () { return !!_this.map; }).subscribe(function (head) {
            _this.setReplayHead(head, _this.map);
        });
    }
    HtSegmentsTrace.prototype.initBaseItems = function (mapType) {
        this.segmentsPolylines = new __WEBPACK_IMPORTED_MODULE_5__entities_segment_polylines__["a" /* HtSegmentPolylines */](mapType);
        this.stopMarkers = new __WEBPACK_IMPORTED_MODULE_6__entities_stop_markers__["a" /* HtStopMarkers */](mapType);
        this.actionMarkers = new __WEBPACK_IMPORTED_MODULE_7__entities_action_markers__["a" /* HtActionMarkers */](mapType);
        this.actionsPolylines = new __WEBPACK_IMPORTED_MODULE_0__map_items__["a" /* HtMapItems */](mapType);
        this.userMarker = new __WEBPACK_IMPORTED_MODULE_3__current_user__["a" /* HtCurrentUser */](mapType);
        this.replayMarker = new __WEBPACK_IMPORTED_MODULE_4__marker_item__["a" /* HtMarkerItem */](mapType);
        this.eventMarkers = new __WEBPACK_IMPORTED_MODULE_0__map_items__["a" /* HtMapItems */](mapType);
        this.initItems(mapType);
    };
    HtSegmentsTrace.prototype.initItems = function (mapType) {
    };
    HtSegmentsTrace.prototype.trace = function (user, map, params) {
        if (params === void 0) { params = {}; }
        this.map = map;
        var userSegments = user && user.segments ? user.segments : [];
        var segType = this.getSegmentTypes(userSegments);
        if (this.segmentsPolylines)
            this.segmentsPolylines.trace(segType.tripSegment, map, true);
        if (this.stopMarkers)
            this.stopMarkers.trace(segType.stopSegment, map, true);
        this.traceAction(user, map);
        this.traceCurrentUser(__WEBPACK_IMPORTED_MODULE_1_underscore__["last"](userSegments), map);
        this.traceActionPolyline(user, map, this.getCurrentUserPosition());
        // this.traceEvents(user, ht-map)
    };
    HtSegmentsTrace.prototype.highlightAll = function (toHighlight) {
        this.segmentsPolylines.highlight({}, !!toHighlight);
        this.stopMarkers.highlight({}, !!toHighlight);
    };
    HtSegmentsTrace.prototype.extendBounds = function (bounds) {
        bounds = this.stopMarkers.extendBounds(bounds);
        bounds = this.segmentsPolylines.extendBounds(bounds);
        bounds = this.actionMarkers.extendBounds(bounds);
        // console.log(bounds, "final");
        return bounds;
    };
    HtSegmentsTrace.prototype.highlightSegmentId = function (segmentId) {
        this.segmentsPolylines.highlight(segmentId);
        this.stopMarkers.hightlight(segmentId);
        // if(segmentId.type == 'trip') {
        //   this.segmentsPolylines.highlight(segment);
        //   this.stopMarkers.unHighlight()
        // } else if (segment.type == 'stop') {
        //   this.stopMarkers.highlight(segment);
        //   // this.segmentsPolylines.unHighlight();
        // }
        // this.selectSegmentEffect(segment)
    };
    HtSegmentsTrace.prototype.unselectSegment = function (segment) {
        if (segment.type == 'trip') {
            this.segmentsPolylines.resetHighlights();
            this.stopMarkers.resetHighlights();
        }
        else if (segment.type == 'stop') {
            // console.log("stop select");
            this.stopMarkers.resetHighlights();
            this.stopMarkers.resetHighlights();
            // this.segmentsPolylines.resetHighlights();
        }
        this.unselectSegmentEffect(segment);
    };
    HtSegmentsTrace.prototype.selectSegmentEffect = function (segment) {
        this.actionMarkers.highlight({});
    };
    HtSegmentsTrace.prototype.unselectSegmentEffect = function (segment) {
        this.actionMarkers.resetHighlights();
    };
    HtSegmentsTrace.prototype.traceAction = function (user, map) {
        var actions = user && user.actions ? user.actions : [];
        var filteredActions = __WEBPACK_IMPORTED_MODULE_1_underscore__["filter"](actions, function (action) {
            return __WEBPACK_IMPORTED_MODULE_8_ht_js_data__["htAction"](action).isValidMarker();
            // return !!((action.expected_place && action.expected_place.location) || (action.completed_place && action.completed_place.location));
        });
        if (this.actionMarkers)
            this.actionMarkers.trace(filteredActions, map, true);
    };
    HtSegmentsTrace.prototype.traceActionPolyline = function (user, map, currentPosition) {
        var actions = user && user.actions ? user.actions : [];
        var ongoingAction = currentPosition ?
            actions : [];
        if (currentPosition) {
            var polylines = this.getActionPolylineWithId(currentPosition, ongoingAction);
            // console.log(polylines);
            this.actionsPolylines.trace(polylines, map, true);
        }
        else {
            this.actionsPolylines.clearAll();
        }
    };
    HtSegmentsTrace.prototype.getActionPolylineWithId = function (currentPosition, items) {
        var sortedAction = __WEBPACK_IMPORTED_MODULE_1_underscore__["sortBy"](items, function (action) {
            var finalEta = action.eta || action.expected_at;
            return finalEta;
        });
        var polylinesWithId = sortedAction.reduce(function (acc, action) {
            var finalEta = action.eta || action.expected_at;
            if (finalEta && !action.display.show_summary) {
                var _a = __WEBPACK_IMPORTED_MODULE_8_ht_js_data__["htAction"](action).getPositionsObject().position, lat = _a.lat, lng = _a.lng;
                var actionPosition = [lat, lng];
                if (acc.length == 0) {
                    return actionPosition ? acc.concat([{
                            path: [currentPosition, actionPosition],
                            id: action.id
                        }]) : acc;
                }
                else {
                    var pastPoint = __WEBPACK_IMPORTED_MODULE_1_underscore__["last"](acc).path[1];
                    return actionPosition ? acc.concat([{
                            path: [pastPoint, actionPosition],
                            id: action.id
                        }]) : acc;
                }
            }
            else {
                return acc;
            }
        }, []);
        return polylinesWithId;
    };
    HtSegmentsTrace.prototype.selectAction = function (actionId) {
        if (actionId) {
            this.actionMarkers.highlight({ id: actionId });
        }
        else {
            this.actionMarkers.resetHighlights();
        }
        this.highlightAll(!!actionId);
    };
    HtSegmentsTrace.prototype.getSegmentTypes = function (userSegments) {
        return __WEBPACK_IMPORTED_MODULE_1_underscore__["reduce"](userSegments, function (segmentType, segment) {
            if (segment.type == 'stop') {
                if (segment.location && segment.location.geojson)
                    segmentType.stopSegment.push(segment);
            }
            else {
                if (segment.encoded_polyline)
                    segmentType.tripSegment.push(segment);
            }
            return segmentType;
        }, { tripSegment: [], stopSegment: [] });
    };
    HtSegmentsTrace.prototype.traceCurrentUser = function (segment, map) {
        if (segment && this.timelineSegment.timeAwareArray && this.timelineSegment.timeAwareArray.length) {
            // let lastSegment = segment;
            var positionBearing = this.timelineSegment.getLastPositionBearing();
            this.userMarker.update({ segment: segment, positionBearing: positionBearing }, map);
        }
        else {
            this.userMarker.clear();
        }
    };
    //segments replay
    HtSegmentsTrace.prototype.clearTimeline = function () {
        this.timelineSegment.clearTimeline();
    };
    Object.defineProperty(HtSegmentsTrace.prototype, "stats", {
        get: function () {
            return this.timelineSegment.stats;
        },
        enumerable: true,
        configurable: true
    });
    // get segments() {
    //   return this.timelineSegment.segments
    // }
    HtSegmentsTrace.prototype.updateTimeline = function (user) {
        this.timelineSegment.update(user);
    };
    HtSegmentsTrace.prototype.getCurrentUserPosition = function () {
        return this.userMarker.getCurrentPosition();
    };
    HtSegmentsTrace.prototype.focusUserMarker = function (map, config) {
        this.userMarker.setFocus(map);
    };
    HtSegmentsTrace.prototype.setSegmentPlayCallback = function (cb) {
        this.timelineSegment.playSegmentCallback = cb;
    };
    HtSegmentsTrace.prototype.setReplayHead = function (head, map) {
        if (head && head.currentPosition) {
            this.replayMarker.setPositionBearing([head.currentPosition[0], head.currentPosition[1]], head.bearing, map);
        }
        else {
            this.replayMarker.clear();
        }
    };
    HtSegmentsTrace.prototype.traceEvents = function (user, map) {
        var _this = this;
        var events = user && user.events ? user.events : [];
        var locations = this.timelineSegment.getLocationsAtTimesT(events.map(function (event) { return event.recorded_at; }));
        var eventsWithPosition = events.reduce(function (acc, event, i) {
            var info = _this.allowedEvents[event.type];
            if (info) {
                var lastEvent = __WEBPACK_IMPORTED_MODULE_1_underscore__["last"](acc);
                var sameAsLastEvent = lastEvent && lastEvent.recorded_at == event.recorded_at;
                if (sameAsLastEvent) {
                    var lastInfo = lastEvent.info + ', ' + info;
                    var newLastEvent = __assign({}, lastEvent, { info: lastInfo });
                    acc.pop();
                    return acc.concat([newLastEvent]);
                }
                else {
                    var position = locations[i];
                    // let position = this.timelinePolyline.getLocationAtTime(event.recorded_at);
                    if (position.length) {
                        var eventWithPosition = __assign({}, event, { position: position, info: info });
                        return acc.concat([eventWithPosition]);
                    }
                    else {
                        return acc;
                    }
                }
            }
            else {
                return acc;
            }
        }, []);
        this.eventMarkers.trace(eventsWithPosition, map, true);
    };
    return HtSegmentsTrace;
}());

;


/***/ }),
/* 9 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TimelineSegment; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__timeline_replay__ = __webpack_require__(10);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_underscore__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_underscore___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_underscore__);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};


var TimelineSegment = (function (_super) {
    __extends(TimelineSegment, _super);
    function TimelineSegment() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    TimelineSegment.prototype.update = function (userData) {
        var _this = this;
        var segments = userData.segments;
        // let noTrackingSegments = this.getNoTrackingSegments(userData.events);
        // console.log(noTrackingSegments);
        var lastUpdated = userData.last_heartbeat_at;
        lastUpdated = lastUpdated || new Date().toISOString();
        var duration = 0;
        var totalTimeAwareArray = [];
        this.allSegments = __WEBPACK_IMPORTED_MODULE_1_underscore__["reduce"](segments, function (acc, segment, i) {
            var segmentLastUpdatedAt = i == segments.length - 1 ? lastUpdated : null;
            var segmentData = _this.getSegmentData(segment, segmentLastUpdatedAt);
            var currentSegment;
            var gapSegment;
            if (segmentData) {
                duration = duration + segmentData.durationSeg;
                totalTimeAwareArray = totalTimeAwareArray.concat(segmentData.timeAwareArray);
                currentSegment = __assign({}, segment, segmentData);
            }
            gapSegment = acc.length && currentSegment ? _this.getGapSegment(currentSegment, __WEBPACK_IMPORTED_MODULE_1_underscore__["last"](acc)) : null;
            if (gapSegment) {
                var gapSegmentData = _this.getSegmentData(gapSegment, segmentLastUpdatedAt);
                duration = duration + gapSegmentData.durationSeg;
                gapSegment = __assign({}, gapSegment, gapSegmentData);
            }
            acc = gapSegment ? acc.concat([gapSegment]) : acc;
            acc = currentSegment ? acc.concat([currentSegment]) : acc;
            return acc;
        }, []);
        this.timeAwareArray = totalTimeAwareArray;
        // this.timeAwareArray = _.sortBy(totalTimeAwareArray, (array => {
        //   let time = new Date(array[2]).getTime();
        //   return Math.floor(time / 60000)
        // }));
        //sorting messes up stop end and trip start points.
        this.duration = duration;
        this.segments = this.getSegmentsWithPercentMarks(this.allSegments, duration);
        var stats = this.getStats(this.segments);
        this.setStats(stats);
        // console.log(this.segments, "deco");
    };
    TimelineSegment.prototype.currentTimeEffects = function (time) {
    };
    TimelineSegment.prototype.currentSegmentEffects = function (currentSegment) {
        if (this.playSegmentCallback) {
            var segment = currentSegment;
            var segmentId = segment ? segment.id : '';
            this.playSegmentCallback(segmentId);
        }
    };
    TimelineSegment.prototype.getCurrentSegment = function (time) {
        var timeStamp = new Date(time).getTime();
        return __WEBPACK_IMPORTED_MODULE_1_underscore__["find"](this.segments, function (segment) {
            return segment.start <= timeStamp && segment.end > timeStamp;
        });
    };
    TimelineSegment.prototype.getSegmentsWithPercentMarks = function (segments, duration) {
        segments = __WEBPACK_IMPORTED_MODULE_1_underscore__["reduce"](segments, function (acc, segment) {
            var startPercent = acc.pStart;
            var segPercent = (segment.durationSeg / duration) * 100;
            var endPercent = Math.min(startPercent + segPercent, 100);
            var filledSegment = __assign({}, segment, { startPercent: startPercent,
                endPercent: endPercent });
            return {
                segments: acc.segments.concat([filledSegment]),
                pStart: endPercent,
                bearing: 0
            };
        }, { segments: [], pStart: 0, bearing: 0 }).segments;
        return segments;
    };
    TimelineSegment.prototype.getTripTimeAwareArray = function (segment, segmentEnd) {
        var timeAwareArray = [];
        // if(segment.start_location && segment.start_location.geojson && segment.started_at) {
        //   let startCord = segment.start_location.geojson.coordinates;
        //   timeAwareArray.push([startCord[1], startCord[0], segment.started_at])
        // }
        if (segment.time_aware_polyline) {
            timeAwareArray.push.apply(timeAwareArray, this.decode(segment.time_aware_polyline));
        }
        else if (segmentEnd) {
            var lastPoint = __WEBPACK_IMPORTED_MODULE_1_underscore__["last"](timeAwareArray);
            if (lastPoint)
                timeAwareArray.push([lastPoint[0], lastPoint[1], segmentEnd]);
        }
        return timeAwareArray;
    };
    TimelineSegment.prototype.getStopTimeAwareArray = function (segment, segmentEnd) {
        var timeAwareArray = [];
        var coord = segment.location && segment.location.geojson ? segment.location.geojson.coordinates : null;
        if (coord) {
            var position = [coord[1], coord[0]];
            timeAwareArray = [position.concat([segment.started_at]), position.concat([segmentEnd])];
        }
        return timeAwareArray;
    };
    TimelineSegment.prototype.getStats = function (segments) {
        if (segments.length) {
            var lastSeg = __WEBPACK_IMPORTED_MODULE_1_underscore__["last"](segments);
            var start = segments[0].start;
            var end = lastSeg.end;
            //todo duration as sum of segments
            var stats = {
                start: new Date(start).toISOString(),
                end: new Date(end).toISOString(),
                duration: end - start,
                distance: 0,
                timeAwarePolylineArray: this.timeAwareArray,
                segments: segments
            };
            return stats;
        }
        return null;
    };
    TimelineSegment.prototype.getSegmentData = function (segment, lastUpdatedAt) {
        var segmentEnd = segment.ended_at || lastUpdatedAt;
        var segmentStart = segment.started_at;
        if (!segmentEnd || !segmentStart)
            return null;
        var end = new Date(segmentEnd).getTime();
        var start = new Date(segmentStart).getTime();
        var durationSeg = end - start;
        var timeAwareArray;
        if (segment.type == 'trip') {
            timeAwareArray = this.getTripTimeAwareArray(segment, segmentEnd);
        }
        else if (!segment.timeAwareArray) {
            timeAwareArray = this.getStopTimeAwareArray(segment, segmentEnd);
        }
        return {
            timeAwareArray: timeAwareArray,
            end: end,
            start: start,
            durationSeg: durationSeg
        };
    };
    TimelineSegment.prototype.getGapSegment = function (segment, segment2) {
        // let firstPoint = ;
        // let lastPoint = _.first(segment.timeAwareArray);
        var started_at = segment2['ended_at'];
        var ended_at = segment['started_at'];
        var timeAwareArray = [];
        // console.log(firstPoint, lastPoint, "fl");
        if (started_at && ended_at) {
            // let started_at = firstPoint[2];
            // let ended_at =  lastPoint[2];
            return segment.start - segment2.end > 3 * 60000 ?
                {
                    ended_at: ended_at,
                    started_at: started_at,
                    timeAwareArray: timeAwareArray,
                    type: 'gap'
                } : null;
        }
        else {
            return null;
        }
    };
    TimelineSegment.prototype.clearTimeline = function () {
        this.clear();
    };
    TimelineSegment.prototype.goToTime = function (time, timePercent) {
        //get head and update head$
        var _a = this.getPositionBearingnAtTime(time), position = _a.position, bearing = _a.bearing;
        var currentSegment = this.getCurrentSegment(time);
        var head = {
            currentTime: time,
            timePercent: timePercent,
            currentPosition: position,
            bearing: bearing,
            currentSegment: currentSegment,
            segmentPercent: 0
        };
        this.currentSegmentEffects(currentSegment);
        this.currentTimeEffects(time);
        this.setReplayHead(head);
    };
    return TimelineSegment;
}(__WEBPACK_IMPORTED_MODULE_0__timeline_replay__["a" /* TimelineReplay */]));



/***/ }),
/* 10 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TimelineReplay; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__time_aware_polyline__ = __webpack_require__(11);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_underscore__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_underscore___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_underscore__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__ = __webpack_require__(18);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_timer__ = __webpack_require__(19);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_timer___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_rxjs_add_observable_timer__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_switchMap__ = __webpack_require__(20);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_switchMap___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_4_rxjs_add_operator_switchMap__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_operator_filter__ = __webpack_require__(21);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_add_operator_filter___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_add_operator_filter__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_rxjs_add_operator_take__ = __webpack_require__(22);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6_rxjs_add_operator_take___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_6_rxjs_add_operator_take__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_rxjs_add_operator_map__ = __webpack_require__(23);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7_rxjs_add_operator_map___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_7_rxjs_add_operator_map__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_rxjs_add_operator_share__ = __webpack_require__(24);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8_rxjs_add_operator_share___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_8_rxjs_add_operator_share__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9_rxjs_add_operator_takeUntil__ = __webpack_require__(25);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9_rxjs_add_operator_takeUntil___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_9_rxjs_add_operator_takeUntil__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10_rxjs_BehaviorSubject__ = __webpack_require__(26);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_10_rxjs_BehaviorSubject___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_10_rxjs_BehaviorSubject__);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};











var TimelineReplay = (function (_super) {
    __extends(TimelineReplay, _super);
    function TimelineReplay() {
        var _this = _super.call(this) || this;
        _this.stats$ = new __WEBPACK_IMPORTED_MODULE_10_rxjs_BehaviorSubject__["BehaviorSubject"](null);
        _this.head$ = new __WEBPACK_IMPORTED_MODULE_10_rxjs_BehaviorSubject__["BehaviorSubject"](null);
        _this.player$ = new __WEBPACK_IMPORTED_MODULE_10_rxjs_BehaviorSubject__["BehaviorSubject"]({ isPlaying: false, isStopped: true, speed: 2 });
        // timelineSegment = new TimelineSegment();
        _this.debug = false;
        _this.frameInterval = 50;
        _this.skipStops = false;
        _this.addListerner();
        return _this;
    }
    TimelineReplay.prototype.addListerner = function () {
        var _this = this;
        this.stats$.subscribe(function (stats) {
            _this.stats = stats;
        });
        this.head$.subscribe(function (head) {
            _this.head = head;
        });
        this.player$.subscribe(function (player) {
            _this.player = player;
            if (player.isStopped)
                _this.currentSegmentEffects(null);
        });
    };
    TimelineReplay.prototype.getPositionBearingnAtTime = function (time) {
        if (!this.stats)
            return null;
        // let currentTimeValue = (timePercent * (this.stats.duration) / 100) + new Date(this.stats.start).getTime();
        // let time = new Date(currentTimeValue).toISOString();
        // console.log(TimeString(time));
        // if(this.player && !this.player.isStopped)
        // if(segment) console.log(segment.type, "segment", TimeString(segment.started_at), TimeString(segment.ended_at));
        var position;
        var bearing;
        var pathSegment = this.getPolylineSegmentForLocationsElapsed(this.timeAwareArray, time);
        if (pathSegment && pathSegment.locations.length > 0) {
            // let pathBeaing = _.last(pathSegment);
            var point = __WEBPACK_IMPORTED_MODULE_1_underscore__["last"](pathSegment.locations);
            position = [point[0], point[1]];
            bearing = pathSegment.bearing;
            // return [point[0], point[1]]
        }
        else {
            // return null
        }
        return { position: position, bearing: bearing };
    };
    TimelineReplay.prototype.setStats = function (stats) {
        this.stats$.next(stats);
    };
    TimelineReplay.prototype.setReplayHead = function (head) {
        this.head$.next(head);
    };
    TimelineReplay.prototype.getReplayStats = function () {
        return this.stats$.share();
    };
    TimelineReplay.prototype.getReplayHead = function () {
        return this.head$.share();
    };
    TimelineReplay.prototype.currentTimeEffects = function (time) {
    };
    TimelineReplay.prototype.currentSegmentEffects = function (segment) {
    };
    TimelineReplay.prototype.getLastPositionBearing = function () {
        var lastSegTime = __WEBPACK_IMPORTED_MODULE_1_underscore__["last"](this.timeAwareArray)[2] + '';
        return this.getPositionBearingnAtTime(lastSegTime);
    };
    TimelineReplay.prototype.getLocationsAtTimesT = function (times) {
        return this.getLocationsAtTimes(this.timeAwareArray, times);
    };
    TimelineReplay.prototype.getBounds = function (bounds) {
        return __WEBPACK_IMPORTED_MODULE_1_underscore__["reduce"](this.timeAwareArray, function (bounds, point) {
            return bounds.extend([+point[0], +point[1]]);
        }, bounds);
    };
    TimelineReplay.prototype.getNoTrackingSegments = function (events) {
        return __WEBPACK_IMPORTED_MODULE_1_underscore__["reduce"](events, function (acc, event) {
            if (acc.start && event.type == 'tracking.started') {
                return {
                    segments: acc.segments.concat([[acc.start, event.recorded_at]]),
                    start: ''
                };
            }
            else if (event.type == 'tracking.ended') {
                return __assign({}, acc, { start: event.recorded_at });
            }
            return acc;
        }, {
            segments: [],
            start: ""
        }).segments;
    };
    //replay player
    TimelineReplay.prototype.goToTimePercent = function (timePercent, toPause) {
        if (toPause === void 0) { toPause = false; }
        if (timePercent < 0)
            timePercent = 0;
        if (timePercent > 100)
            timePercent = 100;
        var time = this.getTimeFromTimePercent(timePercent);
        if (toPause) {
            if (this.player.isStopped)
                this.setPlayer({ isStopped: false });
            this.jumpToTime(time, timePercent);
        }
        else {
            this.goToTime(time, timePercent);
        }
    };
    TimelineReplay.prototype.jumpToTimePercent = function (timePercent) {
        this.goToTimePercent(timePercent, true);
    };
    TimelineReplay.prototype.getNextTimePercent = function (head) {
        return head ? head.timePercent + this.getIncTimePercent(head) : 0;
    };
    TimelineReplay.prototype.getIncTimePercent = function (head) {
        var normalSpeed = 6000;
        var duration = normalSpeed / this.player.speed;
        if (head.currentSegment.type == 'trip') {
            var max = 2 * 60 * 60 * 1000;
            duration = (normalSpeed * Math.min(max, head.currentSegment.durationSeg) / max + normalSpeed) / this.player.speed;
        }
        var segment = head.currentSegment;
        var frameStep = duration / this.frameInterval;
        var segmentGap = (segment.endPercent - segment.startPercent);
        var segmentCurrentGap = segment.endPercent - head.timePercent;
        var maxInc = segmentCurrentGap > 0 ? Math.min(segmentGap, segmentCurrentGap) : segmentGap;
        return Math.min(segmentGap / frameStep, maxInc);
    };
    TimelineReplay.prototype.getTimeFromTimePercent = function (timePercent) {
        var currentTimeValue = (timePercent * (this.stats.duration) / 100) + new Date(this.stats.start).getTime();
        var currentTime = new Date(currentTimeValue).toISOString();
        return currentTime;
    };
    TimelineReplay.prototype.jumpToTime = function (time, timePercent) {
        this.pause();
        this.goToTime(time, timePercent);
    };
    TimelineReplay.prototype.goToTime = function (time, timePercent) {
        //get head and update head$
    };
    TimelineReplay.prototype.clear = function () {
        if (!this.player.isStopped)
            this.stop();
        this.timeAwareArray = null;
        this.setStats(null);
    };
    TimelineReplay.prototype.play = function () {
        var _this = this;
        this.setPlayer({ isStopped: false, isPlaying: true });
        this.playerSub = __WEBPACK_IMPORTED_MODULE_2_rxjs_Observable__["Observable"].timer(0, this.frameInterval).switchMap(function () { return _this.head$.take(1); })
            .map(function (head) { return _this.getNextTimePercent(head); })
            .takeUntil(this.player$.filter(function (player) { return !player.isPlaying; }).take(1))
            .subscribe(function (timePercent) {
            _this.goToTimePercent(timePercent);
        });
    };
    TimelineReplay.prototype.toggleSkipStops = function () {
        this.skipStops = !this.skipStops;
    };
    TimelineReplay.prototype.pause = function () {
        this.setPlayer({ isPlaying: false });
    };
    TimelineReplay.prototype.stop = function () {
        this.jumpToTimePercent(0);
        this.setPlayer({ isStopped: true, isPlaying: false, speed: 2 });
        this.setReplayHead(null);
    };
    TimelineReplay.prototype.setSpeed = function (speed) {
        this.setPlayer({ speed: speed });
    };
    TimelineReplay.prototype.setPlayer = function (obj) {
        this.player$.next(__assign({}, this.player, obj));
    };
    return TimelineReplay;
}(__WEBPACK_IMPORTED_MODULE_0__time_aware_polyline__["a" /* TimeAwarePolyline */]));



/***/ }),
/* 11 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return TimeAwarePolyline; });
var Polyline = __webpack_require__(16);
var TimeAwarePolyline = (function () {
    function TimeAwarePolyline() {
    }
    TimeAwarePolyline.prototype.decode = function (encodedPolyline) {
        return Polyline.decodeTimeAwarePolyline(encodedPolyline);
    };
    TimeAwarePolyline.prototype.getPolylineSegmentsForLocationsElapsed = function (timeAwarePolyline, time) {
        return Polyline.getPolylineSegmentsForLocationsElapsed(timeAwarePolyline, time);
    };
    TimeAwarePolyline.prototype.getPolylineSegmentForLocationsElapsed = function (timeAwarePolyline, time) {
        return Polyline.getLocationsTillTimeStamp(timeAwarePolyline, time);
    };
    TimeAwarePolyline.prototype.getLocationsAtTimes = function (timeAwarePolyline, times) {
        return Polyline.getLocationsAtTimestamps(timeAwarePolyline, times);
    };
    return TimeAwarePolyline;
}());



/***/ }),
/* 12 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HtCurrentUser; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__marker_item__ = __webpack_require__(2);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

var HtCurrentUser = (function (_super) {
    __extends(HtCurrentUser, _super);
    function HtCurrentUser() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HtCurrentUser.prototype.getCurrentPosition = function () {
    };
    return HtCurrentUser;
}(__WEBPACK_IMPORTED_MODULE_0__marker_item__["a" /* HtMarkerItem */]));



/***/ }),
/* 13 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
Object.defineProperty(__webpack_exports__, "__esModule", { value: true });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__map_item__ = __webpack_require__(3);
/* harmony reexport (binding) */ __webpack_require__.d(__webpack_exports__, "HtMapItem", function() { return __WEBPACK_IMPORTED_MODULE_0__map_item__["a"]; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__map_items__ = __webpack_require__(1);
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "HtMapItems", function() { return __WEBPACK_IMPORTED_MODULE_1__map_items__["a"]; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__leaflet_map_utils__ = __webpack_require__(4);
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "ExtendBounds", function() { return __WEBPACK_IMPORTED_MODULE_2__leaflet_map_utils__["b"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "ExtendBoundsWithPolyline", function() { return __WEBPACK_IMPORTED_MODULE_2__leaflet_map_utils__["c"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "SetStyle", function() { return __WEBPACK_IMPORTED_MODULE_2__leaflet_map_utils__["k"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "SetMap", function() { return __WEBPACK_IMPORTED_MODULE_2__leaflet_map_utils__["j"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "ClearItem", function() { return __WEBPACK_IMPORTED_MODULE_2__leaflet_map_utils__["a"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "GetLatlng", function() { return __WEBPACK_IMPORTED_MODULE_2__leaflet_map_utils__["d"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "setEncodedPath", function() { return __WEBPACK_IMPORTED_MODULE_2__leaflet_map_utils__["l"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "HtUpdatePositionPopup", function() { return __WEBPACK_IMPORTED_MODULE_2__leaflet_map_utils__["f"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "HtUpdatePopup", function() { return __WEBPACK_IMPORTED_MODULE_2__leaflet_map_utils__["e"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "HtUpdatePositionTooltip", function() { return __WEBPACK_IMPORTED_MODULE_2__leaflet_map_utils__["g"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "HtUpdateTooltip", function() { return __WEBPACK_IMPORTED_MODULE_2__leaflet_map_utils__["h"]; });
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "LeafletUtils", function() { return __WEBPACK_IMPORTED_MODULE_2__leaflet_map_utils__["i"]; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__marker_item__ = __webpack_require__(2);
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "HtMarkerItem", function() { return __WEBPACK_IMPORTED_MODULE_3__marker_item__["a"]; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__segments_trace__ = __webpack_require__(8);
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "HtSegmentsTrace", function() { return __WEBPACK_IMPORTED_MODULE_4__segments_trace__["a"]; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5__time_aware_polyline__ = __webpack_require__(11);
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "TimeAwarePolyline", function() { return __WEBPACK_IMPORTED_MODULE_5__time_aware_polyline__["a"]; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_6__timeline_replay__ = __webpack_require__(10);
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "TimelineReplay", function() { return __WEBPACK_IMPORTED_MODULE_6__timeline_replay__["a"]; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_7__timeline_segment__ = __webpack_require__(9);
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "TimelineSegment", function() { return __WEBPACK_IMPORTED_MODULE_7__timeline_segment__["a"]; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_8__current_user__ = __webpack_require__(12);
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "HtCurrentUser", function() { return __WEBPACK_IMPORTED_MODULE_8__current_user__["a"]; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_9__map_class__ = __webpack_require__(34);
/* harmony namespace reexport (by provided) */ __webpack_require__.d(__webpack_exports__, "HtMapClass", function() { return __WEBPACK_IMPORTED_MODULE_9__map_class__["a"]; });



// export * from "./action-marker"









/***/ }),
/* 14 */
/***/ (function(module, exports) {

/*
 * Utility functions to decode/encode numbers and array's of numbers
 * to/from strings (Google maps polyline encoding)
 *
 * Extends the L.Polyline and L.Polygon object with methods to convert
 * to and create from these strings.
 *
 * Jan Pieter Waagmeester <jieter@jieter.nl>
 *
 * Original code from:
 * http://facstaff.unca.edu/mcmcclur/GoogleMaps/EncodePolyline/
 * (which is down as of december 2014)
 */

(function () {
    'use strict';

    var defaultOptions = function (options) {
        if (typeof options === 'number') {
            // Legacy
            options = {
                precision: options
            };
        } else {
            options = options || {};
        }

        options.precision = options.precision || 5;
        options.factor = options.factor || Math.pow(10, options.precision);
        options.dimension = options.dimension || 2;
        return options;
    };

    var PolylineUtil = {
        encode: function (points, options) {
            options = defaultOptions(options);

            var flatPoints = [];
            for (var i = 0, len = points.length; i < len; ++i) {
                var point = points[i];

                if (options.dimension === 2) {
                    flatPoints.push(point.lat || point[0]);
                    flatPoints.push(point.lng || point[1]);
                } else {
                    for (var dim = 0; dim < options.dimension; ++dim) {
                        flatPoints.push(point[dim]);
                    }
                }
            }

            return this.encodeDeltas(flatPoints, options);
        },

        decode: function (encoded, options) {
            options = defaultOptions(options);

            var flatPoints = this.decodeDeltas(encoded, options);

            var points = [];
            for (var i = 0, len = flatPoints.length; i + (options.dimension - 1) < len;) {
                var point = [];

                for (var dim = 0; dim < options.dimension; ++dim) {
                    point.push(flatPoints[i++]);
                }

                points.push(point);
            }

            return points;
        },

        encodeDeltas: function (numbers, options) {
            options = defaultOptions(options);

            var lastNumbers = [];

            for (var i = 0, len = numbers.length; i < len;) {
                for (var d = 0; d < options.dimension; ++d, ++i) {
                    var num = numbers[i];
                    var delta = num - (lastNumbers[d] || 0);
                    lastNumbers[d] = num;

                    numbers[i] = delta;
                }
            }

            return this.encodeFloats(numbers, options);
        },

        decodeDeltas: function (encoded, options) {
            options = defaultOptions(options);

            var lastNumbers = [];

            var numbers = this.decodeFloats(encoded, options);
            for (var i = 0, len = numbers.length; i < len;) {
                for (var d = 0; d < options.dimension; ++d, ++i) {
                    numbers[i] = Math.round((lastNumbers[d] = numbers[i] + (lastNumbers[d] || 0)) * options.factor) / options.factor;
                }
            }

            return numbers;
        },

        encodeFloats: function (numbers, options) {
            options = defaultOptions(options);

            for (var i = 0, len = numbers.length; i < len; ++i) {
                numbers[i] = Math.round(numbers[i] * options.factor);
            }

            return this.encodeSignedIntegers(numbers);
        },

        decodeFloats: function (encoded, options) {
            options = defaultOptions(options);

            var numbers = this.decodeSignedIntegers(encoded);
            for (var i = 0, len = numbers.length; i < len; ++i) {
                numbers[i] /= options.factor;
            }

            return numbers;
        },

        encodeSignedIntegers: function (numbers) {
            for (var i = 0, len = numbers.length; i < len; ++i) {
                var num = numbers[i];
                numbers[i] = (num < 0) ? ~(num << 1) : (num << 1);
            }

            return this.encodeUnsignedIntegers(numbers);
        },

        decodeSignedIntegers: function (encoded) {
            var numbers = this.decodeUnsignedIntegers(encoded);

            for (var i = 0, len = numbers.length; i < len; ++i) {
                var num = numbers[i];
                numbers[i] = (num & 1) ? ~(num >> 1) : (num >> 1);
            }

            return numbers;
        },

        encodeUnsignedIntegers: function (numbers) {
            var encoded = '';
            for (var i = 0, len = numbers.length; i < len; ++i) {
                encoded += this.encodeUnsignedInteger(numbers[i]);
            }
            return encoded;
        },

        decodeUnsignedIntegers: function (encoded) {
            var numbers = [];

            var current = 0;
            var shift = 0;

            for (var i = 0, len = encoded.length; i < len; ++i) {
                var b = encoded.charCodeAt(i) - 63;

                current |= (b & 0x1f) << shift;

                if (b < 0x20) {
                    numbers.push(current);
                    current = 0;
                    shift = 0;
                } else {
                    shift += 5;
                }
            }

            return numbers;
        },

        encodeSignedInteger: function (num) {
            num = (num < 0) ? ~(num << 1) : (num << 1);
            return this.encodeUnsignedInteger(num);
        },

        // This function is very similar to Google's, but I added
        // some stuff to deal with the double slash issue.
        encodeUnsignedInteger: function (num) {
            var value, encoded = '';
            while (num >= 0x20) {
                value = (0x20 | (num & 0x1f)) + 63;
                encoded += (String.fromCharCode(value));
                num >>= 5;
            }
            value = num + 63;
            encoded += (String.fromCharCode(value));

            return encoded;
        }
    };

    // Export Node module
    if (typeof module === 'object' && typeof module.exports === 'object') {
        module.exports = PolylineUtil;
    }

    // Inject functionality into Leaflet
    if (typeof L === 'object') {
        if (!(L.Polyline.prototype.fromEncoded)) {
            L.Polyline.fromEncoded = function (encoded, options) {
                return L.polyline(PolylineUtil.decode(encoded), options);
            };
        }
        if (!(L.Polygon.prototype.fromEncoded)) {
            L.Polygon.fromEncoded = function (encoded, options) {
                return L.polygon(PolylineUtil.decode(encoded), options);
            };
        }

        var encodeMixin = {
            encodePath: function () {
                return PolylineUtil.encode(this.getLatLngs());
            }
        };

        if (!L.Polyline.prototype.encodePath) {
            L.Polyline.include(encodeMixin);
        }
        if (!L.Polygon.prototype.encodePath) {
            L.Polygon.include(encodeMixin);
        }

        L.PolylineUtil = PolylineUtil;
    }
})();


/***/ }),
/* 15 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_15__;

/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

module.exports = __webpack_require__(17);


/***/ }),
/* 17 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
* Methods for encoding and decoding time aware polylines
*
* @module polyline
*/

var polyline = {};


var EARTH_RADIUS = 6371;


/**
* Encodes a time aware polyline
*/
polyline.encodeTimeAwarePolyline = function(points) {
    return extendTimeAwarePolyline("", points, null);
}

/**
* Decodes a time aware polyline
*/
polyline.decodeTimeAwarePolyline = function(polyline) {
    // Method to decode a time aware polyline and return gpx logs
    var gpxLogs = [];
    var index = 0;
    var lat = 0;
    var lng = 0;
    var timeStamp = 0;
    var polylineLine = polyline.length;

    while (index < polylineLine) {
        // Decoding dimensions one by one
        var latResult = getDecodedDimensionFromPolyline(polyline, index);
        index = latResult[0];
        var lngResult = getDecodedDimensionFromPolyline(polyline, index);
        index = lngResult[0];
        var timeResult = getDecodedDimensionFromPolyline(polyline, index);
        index = timeResult[0];

        // Resultant variables
        lat += latResult[1];
        lng += lngResult[1];
        timeStamp += timeResult[1];
        gpxLogs.push(getGpxLog(lat, lng, timeStamp));
    }

    return gpxLogs;
}

/**
* Get locations for a list of timestamps from a decoded polyline
*/
polyline.getLocationsAtTimestamps = function(decodedTimeAwarePolyline, timeStamps) {
    var index = 0, locations = [];

    for (index = 0; index < timeStamps.length; index++) {
        var locationsAndBearing = getLocationsTillTimeStamp(decodedTimeAwarePolyline, timeStamps[index]);
        var locationsFound = locationsAndBearing.locations;

        if (locationsFound.length > 0) {
            locations.push(locationsFound[locationsFound.length - 1]);
        } else {
            locations.push([]);
        }
    }

    return locations;
}

/**
* Decodes a time aware polyline to get locations traveled till a timestamp
* to build a live polyline
*/
polyline.getLocationsElapsedByTimestamp = function(decodedTimeAwarePolyline, timeStamp) {
    var locationsAndBearing = getLocationsTillTimeStamp(decodedTimeAwarePolyline, timeStamp);
    return {'path': locationsAndBearing.locations, 'bearing': locationsAndBearing.bearing};
}

/**
* Cut a decoded time aware polyline into segments
*/
polyline.getPolylineSegments = function(decodedTimeAwarePolyline) {
    var lastTimeStamp = decodedTimeAwarePolyline[decodedTimeAwarePolyline.length - 1][2]
    var polylineSegments = getPolylineSegments(decodedTimeAwarePolyline, lastTimeStamp);
    var result = [];

    for (var i=0; i < polylineSegments.length; i++) {
        result.push({'path': removeTimeStamps(polylineSegments[i].segment), 'style': polylineSegments[i].style});
    }

    return result;
}

/**
* Decode a polyline into segments of contiguous location data, which are solid,
* and gaps, which are dotted.
*/
polyline.getPolylineSegmentsForLocationsElapsed = function(decodedTimeAwarePolyline, timeStamp) {
    var polylineSegments = getPolylineSegments(decodedTimeAwarePolyline, timeStamp);
    var result = [];

    for (var i=0; i < polylineSegments.length; i++) {
        var elapsed = polyline.getLocationsElapsedByTimestamp(polylineSegments[i].segment, timeStamp);

        if (elapsed.path.length > 0) {
            result.push({
                'path': elapsed.path, 'bearing': elapsed.bearing, 'style': polylineSegments[i].style
            });
        }
    }

    return result;
}


// Helper methods

function extendTimeAwarePolyline(polyline, points, lastPoint) {
    var lastLat = 0, lastLng = 0, lastTimeStamp = 0;

    if (polyline == null) {
        polyline = '';
    }

    if (lastPoint != null) {
        lastLat = getLat(lastPoint);
        lastLng = getLng(lastPoint);
        lastTimeStamp = getTimeStamp(lastPoint);
    }

    if (points.length < 1) {
        return polyline
    }

    for (var i = 0; i < points.length; i++) {
        var currentGpxLog = points[i];
        var lat = getLat(currentGpxLog);
        var lng = getLng(currentGpxLog);
        var timeStamp = getTimeStamp(currentGpxLog);

        var diffArray = [lat - lastLat, lng - lastLng, timeStamp - lastTimeStamp];

        for (var j = 0; j < diffArray.length; j++) {
            var currentDiff = diffArray[j];
            currentDiff = (currentDiff < 0) ? notOperator(lshiftOperator(currentDiff, 1)) : lshiftOperator(currentDiff, 1);

            while (currentDiff >= 0x20) {
                polyline += String.fromCharCode((0x20 | (currentDiff & 0x1f)) + 63);
                currentDiff = rshiftOperator(currentDiff, 5);
            }

            polyline += String.fromCharCode(currentDiff + 63);
        }

        lastLat = lat, lastLng = lng, lastTimeStamp = timeStamp;
    }

    return polyline;
}

function getDecodedDimensionFromPolyline(polyline, index) {
    // Method to decode one dimension of the polyline
    var result = 1;
    var shift = 0;

    while (true) {
        var polylineChar = polyline[index];
        var b = polylineChar.charCodeAt(0) - 63 - 1;
        index ++;
        result += lshiftOperator(b, shift);
        shift += 5;

        if (b < 0x1f) {
            break;
        }
    }

    if ((result % 2) !== 0) {
        return [index, rshiftOperator(notOperator(result), 1)];
    } else {
        return [index, rshiftOperator(result, 1)];
    }
}

function getLocationsTillTimeStamp(decodedPolyline, timeStamp) {
    var decoded = decodedPolyline;
    // decoded and timeStamps are both in order of times

    var index = 0;
    var currentPair = [];
    var locationsElapsed = [];
    var bearing = 0;

    if (decoded.length == 0) {
        return {'locations': [], 'bearing': bearing};
    }

    // remove times before first time
    var timeStampToFind = timeStamp, startTime = decoded[0][2];

    while (timeStampToFind <= startTime) {
        return {'locations': [[decoded[0][0], decoded[0][1]]], 'bearing': bearing};
    }

    for (index = 0; index < decoded.length; index++) {
        currentPair.push(decoded[index]);

        if (currentPair.length == 2) {
            var timeStampToFind = timeStamp;
            bearing = updateBearing(bearing, currentPair)

            var startTime = currentPair[0][2], endTime = currentPair[1][2];

            if (timeStampToFind > startTime && timeStampToFind <= endTime) {
                // location is in the current pair
                var midLocation = getLocationInPair(currentPair, timeStampToFind);
                locationsElapsed.push(midLocation);
                return {'locations': locationsElapsed, 'bearing': bearing};

                // it is possible that the next timestamp is also in the
                // same pair, hence redo-ing same iteration
                currentPair.pop();
                index --;
            } else {
                currentPair.shift();
            }
        }

        locationsElapsed.push([currentPair[0][0], currentPair[0][1]]);
    }

    return {'locations': locationsElapsed, 'bearing': bearing};
}

polyline.getLocationsTillTimeStamp = getLocationsTillTimeStamp;

function isDifferentSegment(end, start) {
    // function to determine whether a polyline
    // segment split should happen
    var distance = getDistance(start, end);
    return distance > 500;
}

function getPolylineSegments(decoded, timeLimit) {
    // this method breaks polyline till timeStamp when
    // consecutive time difference is greater than 10 minutes
    var segments = [], currentSegment = [];
    var index = 0;

    if (decoded.length == 0) {
        return [];
    }

    var start = decoded[0];

    for (index = 0; index < decoded.length; index++) {
        if (decoded[index][2] <= timeLimit) {

            if (isDifferentSegment(decoded[index], start) && currentSegment.length > 0) {
                // time difference is more than 10 mins, so flush
                segments.push({
                    'segment': currentSegment, 'style': 'solid'
                });

                var lastElement = currentSegment[currentSegment.length-1];
                currentSegment = [lastElement, decoded[index]];

                segments.push({
                    'segment': currentSegment, 'style': 'dotted'
                });

                currentSegment = [decoded[index]];
            } else {
                currentSegment.push(decoded[index]);
            }

            start = decoded[index];
        } else {
            // add one more location so that the locations elapsed
            // method can find an interpolated midpoint
            if (!isDifferentSegment(decoded[index], start)) {
                currentSegment.push(decoded[index]);
            }
            break;
        }
    }

    segments.push({
        'segment': currentSegment, 'style': 'solid'
    });
    return segments;
}

function updateBearing(oldBearing, gpxPair) {
    var start = [gpxPair[0][0], gpxPair[0][1]];
    var end = [gpxPair[1][0], gpxPair[1][1]];
    var newBearing = computeHeading(start, end);

    if (newBearing != 0) {
        return Math.round(newBearing * 100) / 100.0;
    } else {
        return oldBearing;
    }
}

function getLocationInPair(gpxPair, timeStamp) {
    // timeStamp lies between the timeStamps in the gpx logs
    var startLat = gpxPair[0][0],
    startLng = gpxPair[0][1],
    endLat = gpxPair[1][0],
    endLng = gpxPair[1][1],
    startTime = new Date(gpxPair[0][2]),
    endTime = new Date(gpxPair[1][2]),
    currentTime = new Date(timeStamp);
    var gap = (startTime - endTime);
    var ratio = (startTime - currentTime) / gap;
    return gap == 0 ? [endLat, endLat] : [startLat * (1 - ratio) + endLat * ratio, startLng * (1 - ratio) + endLng * ratio];
}

function getNextLatLng(decoded, timeStamp) {
    var polylineLength = decoded.length;

    if (polylineLength > 0) {
        for (var index = 0; index < polylineLength - 1; index++) {
            var currentTimeStamp = decoded[index][2];

            if (timeStamp < currentTimeStamp) {
                return [decoded[index][0], decoded[index][1]];
            }
        }

        return [decoded[polylineLength - 1][0], decoded[polylineLength - 1][1]];
    }
}

function getDistance(origin, destination) {
    // return distance in meters
    var lon1 = toRadian(origin[1]),
        lat1 = toRadian(origin[0]),
        lon2 = toRadian(destination[1]),
        lat2 = toRadian(destination[0]);

    var deltaLat = lat2 - lat1;
    var deltaLon = lon2 - lon1;

    var a = Math.pow(Math.sin(deltaLat/2), 2) + Math.cos(lat1) * Math.cos(lat2) * Math.pow(Math.sin(deltaLon/2), 2);
    var c = 2 * Math.asin(Math.sqrt(a));
    return c * EARTH_RADIUS * 1000;
}

function toRadian(degree) {
    return degree*Math.PI/180;
}

function computeHeading(start, end) {
    var lat1 = toRadian(start[0]);
    var lat2 = toRadian(end[0]);
    var lng1 = toRadian(start[1]);
    var lng2 = toRadian(end[1]);
    return Math.atan2( Math.sin(lng2-lng1) * Math.cos(lat2), Math.cos(lat1)*Math.sin(lat2)-Math.sin(lat1)*Math.cos(lat2)*Math.cos(lng2-lng1))*180/Math.PI;
}

function areEqualLatlngs(latlngA, latlngB) {
    return (latlngA[0] == latlngB[0]) && (latlngA[1] == latlngB[1]);
}

function removeTimeStamps(segment) {
    var result = [];
    for (var i = 0; i < segment.length; i++) {
        result.push([segment[i][0], segment[i][1]]);
    }
    return result;
}

// Methods to convert types

function getCoordinate(intRepresentation) {
    var coordinate = intRepresentation * 0.00001;
    return +coordinate.toFixed(5);
}

function getIsoTime(timeStamp) {
    // timeStamp is in seconds
    return new Date(timeStamp * 1000).toISOString();
}

function getGpxLog(lat, lng, timeStamp) {
    return [
        getCoordinate(lat), getCoordinate(lng), getIsoTime(timeStamp)
    ];
}

function getLat(gpxLog) {
    return Math.round(gpxLog[0] * 100000);
}

function getLng(gpxLog) {
    return Math.round(gpxLog[1] * 100000);
}

function getTimeStamp(gpxLog) {
    return +new Date(gpxLog[2]) / 1000;

}

// Override bit wise operators to circumvent 64 bit int issue

function lshiftOperator(num, bits) {
    // Custom left shift for 64 bit integers
    return num * Math.pow(2, bits);
}

function rshiftOperator(num, bits) {
    // Custom right shift for 64 bit integers
    return Math.floor(num / Math.pow(2, bits));
}

function notOperator(num) {
    // Custom not operator for 64 bit integers
    return ~num;
}


module.exports = polyline


/***/ }),
/* 18 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_18__;

/***/ }),
/* 19 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_19__;

/***/ }),
/* 20 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_20__;

/***/ }),
/* 21 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_21__;

/***/ }),
/* 22 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_22__;

/***/ }),
/* 23 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_23__;

/***/ }),
/* 24 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_24__;

/***/ }),
/* 25 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_25__;

/***/ }),
/* 26 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_26__;

/***/ }),
/* 27 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HtSegmentPolylines; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__map_items__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__segment_polyline__ = __webpack_require__(28);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();


var HtSegmentPolylines = (function (_super) {
    __extends(HtSegmentPolylines, _super);
    function HtSegmentPolylines() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HtSegmentPolylines.prototype.getItem = function (data) {
        var circle = new __WEBPACK_IMPORTED_MODULE_1__segment_polyline__["a" /* HtSegmentPolyline */](this.mapType);
        circle.setMapTypeStyle();
        return circle;
    };
    return HtSegmentPolylines;
}(__WEBPACK_IMPORTED_MODULE_0__map_items__["a" /* HtMapItems */]));



/***/ }),
/* 28 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HtSegmentPolyline; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_ht_js_utils__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_ht_js_utils___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_ht_js_utils__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__polyline__ = __webpack_require__(29);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();


var HtSegmentPolyline = (function (_super) {
    __extends(HtSegmentPolyline, _super);
    function HtSegmentPolyline() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.googleStyle = {
            strokeColor: __WEBPACK_IMPORTED_MODULE_0_ht_js_utils__["Color"].blue,
            strokeOpacity: 1,
            strokeWeight: 5
        };
        return _this;
    }
    return HtSegmentPolyline;
}(__WEBPACK_IMPORTED_MODULE_1__polyline__["a" /* HtPolyline */]));



/***/ }),
/* 29 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HtPolyline; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__map_item__ = __webpack_require__(3);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();

var HtPolyline = (function (_super) {
    __extends(HtPolyline, _super);
    function HtPolyline(mapType, options) {
        var _this = _super.call(this, mapType, options) || this;
        _this.item = _this.mapUtils.getPolyline();
        return _this;
    }
    HtPolyline.prototype.update = function (data, map) {
        this.mapUtils.setEncodedPath(this.item, this.getEncodedPath(data));
    };
    HtPolyline.prototype.getEncodedPath = function (data) {
        return data.encoded_polyline;
    };
    HtPolyline.prototype.extendBounds = function (bounds) {
        return this.mapUtils.extendBoundsWithPolyline(this.item, bounds);
    };
    return HtPolyline;
}(__WEBPACK_IMPORTED_MODULE_0__map_item__["a" /* HtMapItem */]));



/***/ }),
/* 30 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HtStopMarkers; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__map_items__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__stop_marker__ = __webpack_require__(31);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();


var HtStopMarkers = (function (_super) {
    __extends(HtStopMarkers, _super);
    function HtStopMarkers() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HtStopMarkers.prototype.getItem = function (data) {
        var circle = new __WEBPACK_IMPORTED_MODULE_1__stop_marker__["a" /* HtStopMarker */](this.mapType);
        circle.setMapTypeStyle();
        return circle;
    };
    return HtStopMarkers;
}(__WEBPACK_IMPORTED_MODULE_0__map_items__["a" /* HtMapItems */]));



/***/ }),
/* 31 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HtStopMarker; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_ht_js_utils__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_ht_js_utils___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_ht_js_utils__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__marker_item__ = __webpack_require__(2);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();


var HtStopMarker = (function (_super) {
    __extends(HtStopMarker, _super);
    function HtStopMarker() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.leafletStyle = {
            radius: 10,
            fillColor: __WEBPACK_IMPORTED_MODULE_0_ht_js_utils__["Color"].stop,
            fillOpacity: 1,
            weight: 1,
            color: __WEBPACK_IMPORTED_MODULE_0_ht_js_utils__["Color"].stopDark,
            pane: 'markerPane'
        };
        _this.googleStyle = {
            icon: {
                fillColor: __WEBPACK_IMPORTED_MODULE_0_ht_js_utils__["Color"].stop,
                fillOpacity: 1,
                strokeColor: __WEBPACK_IMPORTED_MODULE_0_ht_js_utils__["Color"].stopDark,
                strokeOpacity: 1,
                path: google.maps.SymbolPath.CIRCLE,
                scale: 8,
                strokeWeight: 2,
            }
        };
        return _this;
    }
    HtStopMarker.prototype.setItem = function () {
        this.item = this.mapUtils.getCircleMarker();
    };
    HtStopMarker.prototype.getPosition = function (item) {
        var lat = item.location.geojson.coordinates[1];
        var lng = item.location.geojson.coordinates[0];
        return this.mapUtils.getLatlng({ lat: lat, lng: lng });
    };
    return HtStopMarker;
}(__WEBPACK_IMPORTED_MODULE_1__marker_item__["a" /* HtMarkerItem */]));



/***/ }),
/* 32 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HtActionMarkers; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__map_items__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__action_marker__ = __webpack_require__(33);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();


var HtActionMarkers = (function (_super) {
    __extends(HtActionMarkers, _super);
    function HtActionMarkers() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HtActionMarkers.prototype.getItem = function (data) {
        var circle = new __WEBPACK_IMPORTED_MODULE_1__action_marker__["a" /* HtActionMarker */](this.mapType);
        circle.setMapTypeStyle();
        return circle;
    };
    return HtActionMarkers;
}(__WEBPACK_IMPORTED_MODULE_0__map_items__["a" /* HtMapItems */]));



/***/ }),
/* 33 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HtActionMarker; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__marker_item__ = __webpack_require__(2);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ht_js_utils__ = __webpack_require__(7);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_ht_js_utils___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_ht_js_utils__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ht_js_data__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2_ht_js_data___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_2_ht_js_data__);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();



var HtActionMarker = (function (_super) {
    __extends(HtActionMarker, _super);
    function HtActionMarker() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.leafletSttyle = {
            radius: 10,
            fillColor: __WEBPACK_IMPORTED_MODULE_1_ht_js_utils__["Color"].stop,
            fillOpacity: 1,
            weight: 1,
            opacity: 1,
            color: __WEBPACK_IMPORTED_MODULE_1_ht_js_utils__["Color"].stopDark,
            pane: 'markerPane'
        };
        _this.googleStyle = {
            icon: {
                fillColor: __WEBPACK_IMPORTED_MODULE_1_ht_js_utils__["Color"].blue,
                fillOpacity: 1,
                strokeColor: __WEBPACK_IMPORTED_MODULE_1_ht_js_utils__["Color"].grey5,
                strokeOpacity: 1,
                path: google.maps.SymbolPath.CIRCLE,
                scale: 7,
                strokeWeight: 4,
            }
        };
        return _this;
    }
    HtActionMarker.prototype.setItem = function () {
        this.item = this.mapUtils.getCircleMarker();
    };
    HtActionMarker.prototype.setDataClass = function (action) {
        return __WEBPACK_IMPORTED_MODULE_2_ht_js_data__["htAction"](action);
    };
    HtActionMarker.prototype.getPosition = function (data) {
        var position = this.dataClass.getPositionsObject().position;
        return this.mapUtils.getLatlng(position);
    };
    return HtActionMarker;
}(__WEBPACK_IMPORTED_MODULE_0__marker_item__["a" /* HtMarkerItem */]));



/***/ }),
/* 34 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HtMapClass; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__leaflet_map_utils__ = __webpack_require__(4);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__google_map_utils__ = __webpack_require__(6);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__segments_trace__ = __webpack_require__(8);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3__entities_users_cluster__ = __webpack_require__(35);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_4__map_styles_light_color__ = __webpack_require__(37);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_Subject__ = __webpack_require__(38);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_5_rxjs_Subject___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_5_rxjs_Subject__);
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};






var HtMapClass = (function () {
    function HtMapClass(mapType, options) {
        if (mapType === void 0) { mapType = 'leaflet'; }
        if (options === void 0) { options = {}; }
        this.mapType = mapType;
        this.leafletSetBoundsOptions = {
            animate: true,
            duration: 0.3
        };
        this.googleSetBoundsOptions = {};
        this.googleMapOptions = {
            center: { lat: 0, lng: 0 }, zoom: 2,
            fullscreenControl: false,
            streetViewControl: false,
            styles: __WEBPACK_IMPORTED_MODULE_4__map_styles_light_color__["a" /* LightColorMapStyle */]
        };
        this.leafletMapOptions = { center: [3.505, 0], zoom: 2 };
        this.map$ = new __WEBPACK_IMPORTED_MODULE_5_rxjs_Subject__["Subject"]();
        this.mapUtils = mapType == 'leaflet' ? __WEBPACK_IMPORTED_MODULE_0__leaflet_map_utils__["i" /* LeafletUtils */] : __WEBPACK_IMPORTED_MODULE_1__google_map_utils__["a" /* GoogleMapUtils */];
        // this.initMap(elem, options);
        this.usersCluster = new __WEBPACK_IMPORTED_MODULE_3__entities_users_cluster__["a" /* UsersCluster */](mapType);
        this.segmentTrace = new __WEBPACK_IMPORTED_MODULE_2__segments_trace__["a" /* HtSegmentsTrace */](this.mapType);
    }
    HtMapClass.prototype.initMap = function (elem, options) {
        if (options === void 0) { options = {}; }
        var mapOptions = this.mapType == 'leaflet' ? this.leafletMapOptions : this.googleMapOptions;
        this.map = this.mapUtils.renderMap(elem, __assign({}, mapOptions, options));
        this.usersCluster.markerCluster = this.mapUtils.getMarkerCluster(this.map);
        this.map$.next(this.map);
        return this.map;
    };
    HtMapClass.prototype.tracePlaceline = function (user) {
        this.segmentTrace.trace(user, this.map);
    };
    HtMapClass.prototype.resetBounds = function (options, bounds) {
        var _this = this;
        setTimeout(function () {
            bounds = _this.segmentTrace.extendBounds(bounds);
            bounds = _this.usersCluster.extendBounds(bounds);
            if (bounds && _this.mapUtils.isValidBounds(bounds))
                _this.setBounds(bounds, options);
        }, 10);
    };
    ;
    HtMapClass.prototype.setBounds = function (bounds, options) {
        options = options || this.mapType == 'leaflet' ? this.leafletSetBoundsOptions : this.googleSetBoundsOptions;
        this.mapUtils.setBounds(this.map, bounds, options);
    };
    HtMapClass.prototype.inValidateSize = function () {
        this.mapUtils.invalidateSize(this.map);
    };
    return HtMapClass;
}());



/***/ }),
/* 35 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return UsersCluster; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0__map_items__ = __webpack_require__(1);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_underscore__ = __webpack_require__(0);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1_underscore___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_1_underscore__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_2__user_marker__ = __webpack_require__(36);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_ht_js_data__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_3_ht_js_data___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_3_ht_js_data__);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();




var UsersCluster = (function (_super) {
    __extends(UsersCluster, _super);
    function UsersCluster() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.itemEntities = {};
        _this.setFocusConfig = {
            zoom: 17,
            force: true,
            center: true
        };
        return _this;
    }
    UsersCluster.prototype.onReady = function () {
        this.popup = this.mapUtils.getPopup({
            disableAutoPan: true,
            pixelOffset: new google.maps.Size(0, -37)
        });
    };
    UsersCluster.prototype.extendBounds = function (bounds) {
        bounds = bounds || this.mapUtils.extendBounds();
        if (this.mapType == 'google') {
            var newBounds = __WEBPACK_IMPORTED_MODULE_1_underscore__["reduce"](this.itemEntities, function (bounds, item) {
                return item.extendBounds(bounds);
            }, bounds);
            return newBounds;
            // console.log(this.itemEntities, Object.keys(this.itemEntities).length);
            // let newBounds = Object.keys(this.itemEntities).length ? this.markerCluster.getExtendedBounds(bounds) : bounds
            // return newBounds
        }
        else {
            var newBounds = __WEBPACK_IMPORTED_MODULE_1_underscore__["reduce"](this.itemEntities, function (bounds, item) {
                return item.extendBounds(bounds);
            }, bounds);
            return newBounds;
        }
    };
    UsersCluster.prototype.filteredItem = function (items) {
        return __WEBPACK_IMPORTED_MODULE_1_underscore__["filter"](items, function (item) { return __WEBPACK_IMPORTED_MODULE_3_ht_js_data__["htUser"](item).isValidMarker(); });
    };
    UsersCluster.prototype.getItem = function (item) {
        var _this = this;
        var marker = new __WEBPACK_IMPORTED_MODULE_2__user_marker__["a" /* HtUserMarker */](this.mapType);
        //todo make this configurable
        this.mapUtils.onEvent(marker.item, 'click', function () {
            if (_this.onClick) {
                _this.onClick(marker.data, marker.item);
            }
            else {
                // this.openPopup()
                _this.highlight(marker.data, _this.setFocusConfig);
                // let position = marker.dataClass.getPosition();
                // this.mapUtils.openPopupPosition(position, this.map, this.getInfoContent(marker.data), this.popup)
            }
        });
        this.mapUtils.onEvent(marker.item, 'mouseover', function () {
            _this.openPopup(marker);
        });
        this.mapUtils.onEvent(marker.item, 'mouseout', function () {
            _this.closePopup();
        });
        return marker;
    };
    UsersCluster.prototype.openPopup = function (marker) {
        var position = marker.dataClass.getPosition();
        this.mapUtils.openPopupPosition(position, this.map, this.getInfoContent(marker.data), this.popup);
    };
    UsersCluster.prototype.closePopup = function () {
        this.mapUtils.setMap(this.popup, null);
    };
    UsersCluster.prototype.getInfoContent = function (data) {
        // let data = this.data;
        if (this.options.getInfoContent)
            return this.options.getInfoContent(data);
        var string = "<div>\n<strong>" + data.name + "</strong>\n<div>" + data.display.status_text + "</div>\n<div>" + data.display.sub_status_text + "</div>\n</div>";
        return string;
    };
    UsersCluster.prototype.removeItem = function (mapItem) {
        this.mapUtils.removeClusterMarker(this.markerCluster, mapItem.item);
        _super.prototype.removeItem.call(this, mapItem);
        // this.markerCluster.removeLayer(mapItem.item);
        // super.removeItem(mapItem)
    };
    UsersCluster.prototype.removeItems = function () {
        this.mapUtils.removeClusterMarkers(this.markerCluster);
    };
    UsersCluster.prototype.traceItemEffect = function (itemEntity) {
        // this.mapUtils.removeClusterMarkers(this.markerCluster);
        var userMarkerArray = __WEBPACK_IMPORTED_MODULE_1_underscore__["values"](itemEntity)
            .filter(function (usermarker) {
            // console.log(usermarker.data);
            var isValid = __WEBPACK_IMPORTED_MODULE_3_ht_js_data__["htUser"](usermarker.data).isValidMarker();
            return isValid;
            // console.log(isValid, "isValid");
        })
            .map(function (userMarker) {
            // userMarker = _.filter(userMarker, (userMak))
            return userMarker.item;
        });
        this.mapUtils.addMarkersToCluster(this.markerCluster, userMarkerArray, this.map);
        // this.markerCluster.addLayers(userMarkerArray);
        // this.markerCluster.refreshClusters(userMarkerArray);
    };
    UsersCluster.prototype.highlightItem = function (item, data) {
        // this.mapUtils.setMap(this.popup, null);
        _super.prototype.highlightItem.call(this, item, data, this.setFocusConfig);
        this.mapUtils.openPopupPosition(item.dataClass.getPosition(), this.map, this.getInfoContent(data), this.popup);
    };
    return UsersCluster;
}(__WEBPACK_IMPORTED_MODULE_0__map_items__["a" /* HtMapItems */]));



/***/ }),
/* 36 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return HtUserMarker; });
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_ht_js_data__ = __webpack_require__(5);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_0_ht_js_data___default = __webpack_require__.n(__WEBPACK_IMPORTED_MODULE_0_ht_js_data__);
/* harmony import */ var __WEBPACK_IMPORTED_MODULE_1__marker_item__ = __webpack_require__(2);
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();


var HtUserMarker = (function (_super) {
    __extends(HtUserMarker, _super);
    function HtUserMarker() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    HtUserMarker.prototype.setItem = function () {
        this.item = this.mapUtils.getMarker();
    };
    HtUserMarker.prototype.setDataClass = function (data) {
        return __WEBPACK_IMPORTED_MODULE_0_ht_js_data__["htUser"](data);
    };
    HtUserMarker.prototype.getPosition = function (item) {
        var position = __WEBPACK_IMPORTED_MODULE_0_ht_js_data__["htUser"](item).getPosition();
        if (!position) {
            console.log(item, "no pos");
        }
        return position ? this.mapUtils.getLatlng(position) : null;
    };
    HtUserMarker.prototype.extendBounds = function (bounds) {
        bounds = bounds || this.mapUtils.extendBounds();
        return this.mapUtils.extendBounds(this.item, bounds, true);
    };
    HtUserMarker.prototype.highlight = function (map, data, config) {
        if (config === void 0) { config = {}; }
        this.setDataClass(data);
        this.mapUtils.setFocus(this.item, map, config);
        // this.mapUtils.setMap(this.item, map)
    };
    HtUserMarker.prototype.resetItem = function () {
        // this.mapUtils.setMap(this.item, null)
    };
    return HtUserMarker;
}(__WEBPACK_IMPORTED_MODULE_1__marker_item__["a" /* HtMarkerItem */]));



/***/ }),
/* 37 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "a", function() { return LightColorMapStyle; });
var LightColorMapStyle = [
    {
        "featureType": "all",
        "elementType": "labels.text.fill",
        "stylers": [
            {
                "saturation": 36
            },
            {
                "color": "#333333"
            },
            {
                "lightness": 40
            }
        ]
    },
    {
        "featureType": "all",
        "elementType": "labels.text.stroke",
        "stylers": [
            {
                "visibility": "on"
            },
            {
                "color": "#ffffff"
            },
            {
                "lightness": 16
            }
        ]
    },
    {
        "featureType": "all",
        "elementType": "labels.icon",
        "stylers": [
            {
                "visibility": "off"
            }
        ]
    },
    {
        "featureType": "administrative",
        "elementType": "geometry.fill",
        "stylers": [
            {
                "color": "#fefefe"
            },
            {
                "lightness": 20
            }
        ]
    },
    {
        "featureType": "administrative",
        "elementType": "geometry.stroke",
        "stylers": [
            {
                "color": "#fefefe"
            },
            {
                "lightness": 17
            },
            {
                "weight": 1.2
            }
        ]
    },
    {
        "featureType": "landscape",
        "elementType": "geometry",
        "stylers": [
            {
                "color": "#f5f5f5"
            },
            {
                "lightness": 20
            },
            {
                "visibility": "off"
            }
        ]
    },
    {
        "featureType": "landscape",
        "elementType": "labels",
        "stylers": [
            {
                "visibility": "off"
            }
        ]
    },
    {
        "featureType": "landscape",
        "elementType": "labels.text",
        "stylers": [
            {
                "visibility": "off"
            }
        ]
    },
    {
        "featureType": "landscape.natural",
        "elementType": "geometry.fill",
        "stylers": [
            {
                "visibility": "off"
            }
        ]
    },
    {
        "featureType": "landscape.natural",
        "elementType": "geometry.stroke",
        "stylers": [
            {
                "visibility": "off"
            }
        ]
    },
    {
        "featureType": "landscape.natural",
        "elementType": "labels.text",
        "stylers": [
            {
                "visibility": "off"
            }
        ]
    },
    {
        "featureType": "landscape.natural",
        "elementType": "labels.text.fill",
        "stylers": [
            {
                "visibility": "off"
            }
        ]
    },
    {
        "featureType": "landscape.natural",
        "elementType": "labels.text.stroke",
        "stylers": [
            {
                "visibility": "off"
            }
        ]
    },
    {
        "featureType": "landscape.natural.landcover",
        "elementType": "labels.text",
        "stylers": [
            {
                "visibility": "off"
            }
        ]
    },
    {
        "featureType": "poi",
        "elementType": "all",
        "stylers": [
            {
                "visibility": "off"
            }
        ]
    },
    {
        "featureType": "poi",
        "elementType": "geometry",
        "stylers": [
            {
                "color": "#f5f5f5"
            },
            {
                "lightness": 21
            }
        ]
    },
    {
        "featureType": "poi.park",
        "elementType": "geometry",
        "stylers": [
            {
                "color": "#dedede"
            },
            {
                "lightness": 21
            }
        ]
    },
    {
        "featureType": "road.highway",
        "elementType": "geometry.fill",
        "stylers": [
            {
                "color": "#ffffff"
            },
            {
                "lightness": 17
            }
        ]
    },
    {
        "featureType": "road.highway",
        "elementType": "geometry.stroke",
        "stylers": [
            {
                "color": "#ffffff"
            },
            {
                "lightness": 29
            },
            {
                "weight": 0.2
            }
        ]
    },
    {
        "featureType": "road.arterial",
        "elementType": "geometry",
        "stylers": [
            {
                "color": "#ffffff"
            },
            {
                "lightness": 18
            }
        ]
    },
    {
        "featureType": "road.local",
        "elementType": "all",
        "stylers": [
            {
                "visibility": "off"
            }
        ]
    },
    {
        "featureType": "road.local",
        "elementType": "geometry",
        "stylers": [
            {
                "color": "#ffffff"
            },
            {
                "lightness": 16
            }
        ]
    },
    {
        "featureType": "transit",
        "elementType": "all",
        "stylers": [
            {
                "visibility": "off"
            }
        ]
    },
    {
        "featureType": "transit",
        "elementType": "geometry",
        "stylers": [
            {
                "color": "#f2f2f2"
            },
            {
                "lightness": 19
            }
        ]
    },
    {
        "featureType": "water",
        "elementType": "geometry",
        "stylers": [
            {
                "color": "#e9e9e9"
            },
            {
                "lightness": 17
            }
        ]
    }
];


/***/ }),
/* 38 */
/***/ (function(module, exports) {

module.exports = __WEBPACK_EXTERNAL_MODULE_38__;

/***/ })
/******/ ]);
});