import { HtBounds, HtMap, HtMapType, MapUtils } from "./interfaces";
import { HtSegmentsTrace } from "./segments-trace";
import { IUserData } from "ht-models";
import { Subject } from "rxjs/Subject";
export declare class HtMapClass {
    mapType: HtMapType;
    map: HtMap;
    mapUtils: MapUtils;
    segmentTrace: HtSegmentsTrace;
    usersCluster: any;
    leafletSetBoundsOptions: L.PanOptions;
    googleSetBoundsOptions: {};
    googleMapOptions: {
        center: {
            lat: number;
            lng: number;
        };
        zoom: number;
        fullscreenControl: boolean;
        streetViewControl: boolean;
        styles: ({
            "featureType": string;
            "elementType": string;
            "stylers": ({
                "saturation": number;
            } | {
                "color": string;
            } | {
                "lightness": number;
            })[];
        } | {
            "featureType": string;
            "elementType": string;
            "stylers": ({
                "visibility": string;
            } | {
                "color": string;
            } | {
                "lightness": number;
            })[];
        } | {
            "featureType": string;
            "elementType": string;
            "stylers": ({
                "color": string;
            } | {
                "lightness": number;
            } | {
                "weight": number;
            })[];
        })[];
    };
    leafletMapOptions: {
        center: number[];
        zoom: number;
    };
    map$: Subject<{}>;
    constructor(mapType?: HtMapType, options?: HtMapClassOptions);
    initMap(elem: Element, options?: {}): HtMap;
    tracePlaceline(user: IUserData): void;
    resetBounds(options?: any, bounds?: HtBounds): void;
    setBounds(bounds: HtBounds, options?: any): void;
    inValidateSize(): void;
}
export interface HtMapClassOptions {
}
