import { HtBounds, HtMap, HtMapType, MapUtils, HtMapItemOptions, SetFocusConfig } from "./interfaces";
export declare class HtMapItem<T> {
    mapType: HtMapType;
    options: HtMapItemOptions<T>;
    item: any;
    data: T;
    dataClass: any;
    isFaded: boolean;
    isHighlighted: boolean;
    isOld: boolean;
    id: string | number;
    defaultStyle: any;
    googleStyle: {};
    leafletStyle: {};
    mapUtils: MapUtils;
    defaultOptions: {
        mapType: string;
        defaultStyle: {};
    };
    constructor(mapType: HtMapType, options?: HtMapItemOptions<T>);
    setItem(): void;
    setMapTypeStyle(): void;
    update(item: any, map: HtMap): void;
    onUpdate(item: any, map: any): void;
    updateItem(data: T): void;
    setDataClass(data: any): any;
    extendBounds(bounds: HtBounds): HtBounds;
    setMap(map: any): void;
    clear(): void;
    resetHighlight(map: any): void;
    reset(): void;
    resetItem(): void;
    setStyle(style: any): void;
    getItemInfoContent(): string;
    getInfoContent(data: any): string;
    openPopup(item: any, content?: string): void;
    closePopup(): void;
    openTooltip(content?: string): void;
    closeTooltip(): void;
    bringToFront(): void;
    highlight(map: HtMap, data: T, config?: SetFocusConfig): void;
    unHighlight(map: HtMap): void;
    setFocus(map: any, config?: SetFocusConfig): void;
}
