import { HtMap, HtMapItemsOptions, HtMapType, MapUtils, SetFocusConfig } from "./interfaces";
import { HtMapItem } from "./map-item";
export declare class HtMapItems<T> {
    mapType: HtMapType;
    options: HtMapItemsOptions<T>;
    itemEntities: {
        [id: string]: HtMapItem<T>;
    };
    defaultStyle: {};
    fadeStyle: {};
    map: any;
    mapUtils: MapUtils;
    defaultOptions: {
        mapType: string;
        defaultStyle: {};
    };
    constructor(mapType: HtMapType, options?: HtMapItemsOptions<T>);
    onReady(options?: {}): void;
    traceOnMap(items: T[], map: HtMap): void;
    trace(items: T[], map: HtMap, setMap?: boolean): void;
    filteredItem(items: any): any;
    getItem(data: T): HtMapItem<T>;
    itemEffect(item: any): void;
    traceItemEffect(itemEntities: {}): void;
    extendBounds(bounds: any): any;
    addClick(cb: any): void;
    onHoverIn(cb: any): void;
    onHoverOut(cb: any): void;
    unHighlight(): void;
    highlight(data: any, config?: SetFocusConfig): void;
    unHighlightItem(item: any): void;
    highlightItem(item: any, data?: any, config?: {}): void;
    setFade(selectedItem: any, toFade?: boolean): void;
    resetHighlights(): void;
    onEach(cb: any): void;
    resetHighlight(item: any): void;
    resetItems(): void;
    resetItem(item: any): void;
    bustOlditem(): void;
    private traceItems(items, setMap?);
    private updateItem(data, setMap?);
    private createItem(data, setMap?);
    removeItem(item: any): void;
    clearAll(): void;
    removeItems(): void;
}
